// -------------------------------------------------------------------------------
// 
// 		cwCu		ʐMvOwb_t@C
// 
// 				Ver 3.12a
// 
// -------------------------------------------------------------------------------

#ifndef __DXARCHIVE_H__
#define __DXARCHIVE_H__

// CN[h -------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxThread.h"

namespace DxLib
{

// }N` --------------------------------------------------------------------

// cwA[JCu֘A

/*
	f[^}bv
		
	DXARC_HEAD
	t@Cf[^
	t@Ce[u
	DXARC_FILEHEAD e[u
	DXARC_DIRECTORY e[u


	t@C̃f[^`
	2byte:̒(oCgTCYS)
	2byte:̃peBf[^(SĂ̒̕l𑫂)
	p͑啶ɕϊꂽt@C̃f[^(S̔{̃TCY)
	p啶ɕϊĂȂt@C̃f[^
*/

#define DXAHEAD						*((WORD *)"DX")		// wb_
#define DXAVER						(0x0006)			// o[W
#define DXAVER_VER5					(0x0005)			// o[W
#define DXA_DIR_MAXARCHIVENUM		(4096)				// ɊJĂA[JCut@C̐
#define DXA_DIR_MAXFILENUM			(32768)				// ɊJĂt@C̐
#define DXA_KEYSTR_LENGTH			(12)				// ̒
#define DXA_MAXDRIVENUM				(64)				// ΉhCu̍ő吔

// \̒` --------------------------------------------------------------------

// A[JCuf[^̍ŏ̃wb_
struct DXARC_HEAD
{
	WORD						Head ;							// hc
	WORD						Version ;						// o[W
	DWORD						HeadSize ;						// wb_ DXARC_HEAD 𔲂STCY
	ULONGLONG					DataStartAddress ;				// ŏ̃t@C̃f[^i[Ăf[^AhX(t@C̐擪AhXAhXOƂ)
	ULONGLONG					FileNameTableStartAddress ;		// t@Ce[u̐擪AhX(t@C̐擪AhXAhXOƂ)
	ULONGLONG					FileTableStartAddress ;			// t@Ce[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
	ULONGLONG					DirectoryTableStartAddress ;	// fBNge[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
																// AhXOzuĂ DXARC_DIRECTORY \̂[gfBNg
	ULONGLONG					CodePage ;						// t@CɎgpĂR[hy[Wԍ( Ver4ȍ~ )
} ;

// A[JCuf[^̍ŏ̃wb_
struct DXARC_HEAD_VER5
{
	WORD						Head ;							// hc
	WORD						Version ;						// o[W
	DWORD						HeadSize ;						// wb_ DXARC_HEAD 𔲂STCY
	DWORD						DataStartAddress ;				// ŏ̃t@C̃f[^i[Ăf[^AhX(t@C̐擪AhXAhXOƂ)
	DWORD						FileNameTableStartAddress ;		// t@Ce[u̐擪AhX(t@C̐擪AhXAhXOƂ)
	DWORD						FileTableStartAddress ;			// t@Ce[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
	DWORD						DirectoryTableStartAddress ;	// fBNge[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
																// AhXOzuĂ DXARC_DIRECTORY \̂[gfBNg
	DWORD						CodePage ;						// t@CɎgpĂR[hy[Wԍ( Ver4ȍ~ )
} ;

// t@C̎ԏ
struct DXARC_FILETIME
{
	ULONGLONG					Create ;						// 쐬
	ULONGLONG					LastAccess ;					// ŏIANZX
	ULONGLONG					LastWrite ;						// ŏIXV
} ;

// t@Cf[^\
struct DXARC_FILENAME
{
	WORD						Length ;						// ̒S
	WORD						Parity ;						// peB
} ;

// t@Ci[
struct DXARC_FILEHEAD
{
	ULONGLONG					NameAddress ;					// t@Ci[ĂAhX( ARCHIVE_HEAD\ ̃oϐ FileNameTableStartAddress ̃AhXAhXOƂ) 
	ULONGLONG					Attributes ;					// t@C
	DXARC_FILETIME				Time ;							// ԏ
	ULONGLONG					DataAddress ;					// t@Ci[ĂAhX
																//			t@C̏ꍇFDXARC_HEAD\ ̃oϐ DataStartAddress AhXAhXOƂ
																//			fBNg̏ꍇFDXARC_HEAD\ ̃oϐ DirectoryTableStartAddress ̂AhXAhXOƂ
	ULONGLONG					DataSize ;						// t@C̃f[^TCY
	ULONGLONG					PressDataSize ;					// k̃f[^̃TCY( 0xffffffff:kĂȂ ) ( Ver0x0002 Œǉꂽ )
} ;

// t@Ci[
struct DXARC_FILEHEAD_VER5
{
	DWORD						NameAddress ;					// t@Ci[ĂAhX( ARCHIVE_HEAD\ ̃oϐ FileNameTableStartAddress ̃AhXAhXOƂ) 
	DWORD						Attributes ;					// t@C
	DXARC_FILETIME				Time ;							// ԏ
	DWORD						DataAddress ;					// t@Ci[ĂAhX
																//			t@C̏ꍇFDXARC_HEAD\ ̃oϐ DataStartAddress AhXAhXOƂ
																//			fBNg̏ꍇFDXARC_HEAD\ ̃oϐ DirectoryTableStartAddress ̂AhXAhXOƂ
	DWORD						DataSize ;						// t@C̃f[^TCY
	DWORD						PressDataSize ;					// k̃f[^̃TCY( 0xffffffff:kĂȂ ) ( Ver0x0002 Œǉꂽ )
} ;

// t@Ci[(Ver0x0001 p)
struct DXARC_FILEHEAD_VER1
{
	DWORD						NameAddress ;					// t@Ci[ĂAhX( ARCHIVE_HEAD\ ̃oϐ FileNameTableStartAddress ̃AhXAhXOƂ) 
	DWORD						Attributes ;					// t@C
	DXARC_FILETIME				Time ;							// ԏ
	DWORD						DataAddress ;					// t@Ci[ĂAhX
																//			t@C̏ꍇFDXARC_HEAD\ ̃oϐ DataStartAddress AhXAhXOƂ
																//			fBNg̏ꍇFDXARC_HEAD\ ̃oϐ DirectoryTableStartAddress ̂AhXAhXOƂ
	DWORD						DataSize ;						// t@C̃f[^TCY
} ;

// fBNgi[
struct DXARC_DIRECTORY
{
	ULONGLONG					DirectoryAddress ;				//  DXARC_FILEHEAD i[ĂAhX( DXARC_HEAD \ ̃oϐ FileTableStartAddress AhXAhXOƂ)
	ULONGLONG					ParentDirectoryAddress ;		// efBNg DXARC_DIRECTORY i[ĂAhX( DXARC_HEAD\ ̃oϐ DirectoryTableStartAddress AhXAhXOƂ)
	ULONGLONG					FileHeadNum ;					// fBNg̃t@C̐
	ULONGLONG					FileHeadAddress ;				// fBNg̃t@C̃wb_񂪊i[ĂAhX( DXARC_HEAD\ ̃oϐ FileTableStartAddress AhXAhXOƂ) 
} ;

// fBNgi[
struct DXARC_DIRECTORY_VER5
{
	DWORD						DirectoryAddress ;				//  DXARC_FILEHEAD i[ĂAhX( DXARC_HEAD \ ̃oϐ FileTableStartAddress AhXAhXOƂ)
	DWORD						ParentDirectoryAddress ;		// efBNg DXARC_DIRECTORY i[ĂAhX( DXARC_HEAD\ ̃oϐ DirectoryTableStartAddress AhXAhXOƂ)
	DWORD						FileHeadNum ;					// fBNg̃t@C̐
	DWORD						FileHeadAddress ;				// fBNg̃t@C̃wb_񂪊i[ĂAhX( DXARC_HEAD\ ̃oϐ FileTableStartAddress AhXAhXOƂ) 
} ;



// t@Cpf[^\
struct DXARC_SEARCHDATA
{
	BYTE						FileName[1024] ;				// t@C
	WORD						Parity ;						// peB
	WORD						PackNum ;						// ̒S
} ;

// e[u\
struct DXARC_TABLE
{
	BYTE						*Top ;							// e[u̐擪|C^
	BYTE						*FileTable ;					// t@Ce[uւ̃|C^
	BYTE						*DirectoryTable ;				// fBNge[uւ̃|C^
	BYTE						*NameTable ;					// Oe[uւ̃|C^
} ;

// A[JCup\
struct DXARC
{
	int							V5Flag ;						// Ver5ȑOǂ( TRUE:Ver5ȑO  FALSE:Ver5ȍ~ )
	union
	{
		DXARC_HEAD				Head ;							// A[JCũwb_
		DXARC_HEAD_VER5			HeadV5 ;						// A[JCũwb_(Ver5ȑO)
	};
	int							CharSet ;						// 񔻒pLZbg
	DWORD_PTR					WinFilePointer__ ;				// A[JCut@C̃|C^	
	void						*MemoryImage ;					// C[WJꍇ̃AhX
	DXARC_TABLE					Table ;							// ee[uւ̐擪AhXi[ꂽ\
	union
	{
		DXARC_DIRECTORY			*CurrentDirectory ;				// JgfBNgf[^ւ̃|C^
		DXARC_DIRECTORY_VER5	*CurrentDirectoryV5 ;			// JgfBNgf[^ւ̃|C^(Ver5ȑO)
	};

	TCHAR						FilePath[1024] ;				// t@CpX
	unsigned char				Key[DXA_KEYSTR_LENGTH] ;		// 
	int							MemoryOpenFlag ;				// ̃t@CJĂ邩AtO
	int							UserMemoryImageFlag ;			// [U[WJC[WgpĂ邩AtO
	LONGLONG					MemoryImageSize ;				// ̃t@CJĂꍇ̃C[W̃TCY
	int							MemoryImageCopyFlag ;			// ̃C[WRs[ĎgpĂ邩ǂ̃tO
	int							MemoryImageReadOnlyFlag ;		// ̃C[Wǂݎpǂ̃tO
	void						*MemoryImageOriginal ;			// ̃C[WRs[ĎgpĂꍇ́ARs[̃f[^i[Ă郁̈

	int							ASyncOpenFlag ;					// 񓯊ǂݍݒtO( TRUE:񓯊ǂݍݒ FALSE:Ⴄ )
	DWORD_PTR					ASyncOpenFilePointer ;			// 񓯊I[vɎgpt@C̃|C^
} ;

// 񓯊ǂݍݏ
#define DXARC_STREAM_ASYNCSTATE_IDLE			(0)				// ĂȂ
#define DXARC_STREAM_ASYNCSTATE_PRESSREAD		(1)				// kꂽt@Cǂݍݒ
#define DXARC_STREAM_ASYNCSTATE_READ			(2)				// f[^ǂݍݒ

// A[JCũt@Cʏ̃t@Cǂݍ݂̂悤ɏׂ̍\
struct DXARC_STREAM
{
	DXARC						*Archive ;						// A[JCuf[^ւ̃|C^
	union
	{
		DXARC_FILEHEAD			*FileHead ;						// t@Cւ̃|C^
		DXARC_FILEHEAD_VER5		*FileHeadV5 ;					// t@Cւ̃|C^(Ver5ȑO)
	};
	void						*DecodeDataBuffer ;				// 𓀂f[^i[Ă郁̈ւ̃|C^( t@Ckf[^ꍇ̂ݗL )
	void						*DecodeTempBuffer ;				// kf[^ꎞۑp̈ւ̃|C^
	DWORD_PTR					WinFilePointer ;				// A[JCut@C̃|C^

	int							EOFFlag ;						// EOFtO
	ULONGLONG					FilePoint ;						// t@C|C^
	int							UseASyncReadFlag ;				// 񓯊ǂݍ݃tO
	int							ASyncState ;					// 񓯊ǂݍݏ( DXARC_STREA_ASYNCSTATE n )
	ULONGLONG					ASyncReadFileAddress ;			// 񓯊ǂݍݎ̃t@C|C^

	void						*ReadBuffer ;					// 񓯊ǂݍݎ̈ɓnꂽobt@ւ̃|C^
	LONGLONG					ReadSize ;						// 񓯊ǂݍݎ̈ɓnꂽǂݍ݃TCYւ̃|C^
} ;



// A[JCut@CfBNgɌĂ鏈p̊JĂA[JCut@C̏
struct DXARC_DIR_ARCHIVE
{
	int							UseCounter ;					// ̃A[JCut@CgpĂ鐔
	DXARC						Archive ;						// A[JCut@Cf[^
	TCHAR						Path[256] ;						// A[JCut@C̃pX
} ;

// A[JCut@CfBNgɌĂ鏈p̊JĂA[JCut@C̃t@C̏
struct DXARC_DIR_FILE
{
	int							UseArchiveFlag ;				// A[JCut@CgpĂ邩tO
	DWORD_PTR					WinFilePointer_ ;				// A[JCugpĂȂꍇ́At@C|C^
	DWORD						UseArchiveIndex ;				// A[JCugpĂꍇAgpĂA[JCut@Cf[^̃CfbNX
	DXARC_STREAM				DXAStream ;						// A[JCut@CgpĂꍇ̃t@CANZXpf[^
} ;

// A[JCufBNgɌĂ鏈p̍\
struct DXARC_DIR
{
	int							InitializeFlag ;				// tO
	DX_CRITICAL_SECTION			CriticalSection ;				// ɃA[JCut@C̃Xg𑀍삵Ȃ悤ɂ邽߂̃NeBJZNV

	DXARC_DIR_ARCHIVE			*Archive[DXA_DIR_MAXARCHIVENUM] ;	// gpĂA[JCut@C̃f[^
	DXARC_DIR_FILE				*File[DXA_DIR_MAXFILENUM] ;		// JĂt@C̃f[^
	TCHAR						ArchiveExtension[64] ;			// A[JCut@C̊gq
	int							ArchiveExtensionLength ;		// A[JCut@C̊gq̒
	int							DXAPriority ;					// cwA[JCut@C̗Dx( 1:tH_D 0:DXA[JCuD )

	int							ValidKeyString ;					// KeyString Lǂ
	char						KeyString[DXA_KEYSTR_LENGTH + 1 ] ;	// 

	int							ArchiveNum ;					// gpĂA[JCut@C̐
	int							FileNum ;						// JĂt@C̐

	int							BackUseArchiveIndex ;			// OgpA[JCũCfbNX
	TCHAR						BackUseDirectory[256] ;			// OgpfBNgpX
	int							BackUseDirectoryPathLength ;	// OgpfBNgpX̒
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 -------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

#ifndef DX_NON_DXA

extern	int			DXA_Initialize(					DXARC *DXA ) ;													// A[JCut@Cׂ̍\̂
extern	int			DXA_Terminate(					DXARC *DXA ) ;													// A[JCut@Cׂ̍\̂̌n
extern	int			DXA_OpenArchiveFromFile(		DXARC *DXA, const TCHAR *ArchivePath, const char *KeyString = NULL ) ;							// A[JCut@CJ( 0:  -1:s )
extern	int			DXA_OpenArchiveFromFileUseMem(	DXARC *DXA, const TCHAR *ArchivePath, const char *KeyString = NULL , int ASync = FALSE ) ;		// A[JCut@CJŏɂׂăɓǂݍł珈( 0:  -1:s )
extern	int			DXA_OpenArchiveFromMem(			DXARC *DXA, void *ArchiveImage, int ArchiveSize, int ArchiveImageCopyFlag, int ArchiveImageReadOnlyFlag, const char *KeyString = NULL, const TCHAR *EmulateArchivePath = NULL) ;				// ɂA[JCut@CC[WJ( 0:  -1:s )
extern	int			DXA_CheckIdle(					DXARC *DXA ) ;													// A[JCut@C𓾂( TRUE:Ă  FALSE:ĂȂ )
extern	int			DXA_CloseArchive(				DXARC *DXA ) ;													// A[JCut@C

extern	int			DXA_LoadFile(					DXARC *DXA, const char *FilePath, void *Buffer, ULONGLONG BufferSize ) ;	// A[JCut@C̎w̃t@Cɓǂݍ( -1:G[ 0ȏ:t@CTCY )
extern	void *		DXA_GetFileImage(				DXARC *DXA ) ;													// A[JCut@Cɓǂݍ񂾏ꍇ̃t@CC[Wi[Ă擪AhX擾( DXA_OpenArchiveFromFileUseMem Ⴕ DXA_OpenArchiveFromMem ŊJꍇɗLAf[^kĂꍇ͒ )
extern	int			DXA_GetFileInfo(				DXARC *DXA, const char *FilePath, int *Position, int *Size ) ;	// A[JCut@C̎w̃t@C̃t@C̈ʒuƃt@C̑傫𓾂( -1:G[ )
extern	int			DXA_ChangeCurrentDir(			DXARC *DXA, const char *DirPath ) ;								// A[JCũJgfBNgύX( 0:  -1:s )
extern	int			DXA_GetCurrentDir(				DXARC *DXA, char *DirPathBuffer, int BufferSize ) ;				// A[JCũJgfBNg擾
extern	DWORD_PTR	DXA_FindFirst(					DXARC *DXA, const char *FilePath, FILEINFO *Buffer ) ;			// A[JCũIuWFNg( -1:G[ -1ȊO:DXAnh )
extern	int			DXA_FindNext(					DWORD_PTR DxaFindHandle, FILEINFO *Buffer ) ;					// A[JCũIuWFNg( -1:G[ 0: )
extern	int			DXA_FindClose(					DWORD_PTR DxaFindHandle ) ;										// A[JCũIuWFNgI

extern	int			DXA_STREAM_Initialize(			DXARC_STREAM *DXAStream, DXARC *DXA, const char *FilePath, int UseASyncReadFlag ) ;	// A[JCut@C̃t@CJ
extern	int			DXA_STREAM_Terminate(			DXARC_STREAM *DXAStream ) ;										// A[JCut@C̃t@C
extern	int			DXA_STREAM_Read(				DXARC_STREAM *DXAStream, void *Buffer, size_t ReadLength ) ;	// t@C̓eǂݍ
extern	int			DXA_STREAM_Seek(				DXARC_STREAM *DXAStream, LONGLONG SeekPoint, int SeekMode ) ;	// t@C|C^ύX
extern	LONGLONG	DXA_STREAM_Tell(				DXARC_STREAM *DXAStream ) ;										// ݂̃t@C|C^𓾂
extern	int			DXA_STREAM_Eof(					DXARC_STREAM *DXAStream ) ;										// t@C̏I[ɗĂ邩ÃtO𓾂
extern	int			DXA_STREAM_IdleCheck(			DXARC_STREAM *DXAStream ) ;										// ǂݍݏĂ邩ǂ𒲂ׂ
extern	LONGLONG	DXA_STREAM_Size(				DXARC_STREAM *DXAStream ) ;										// t@C̃TCY擾


extern	int			DXA_DIR_Initialize(				void ) ;														// A[JCufBNgɌĂ鏈̏
extern	int			DXA_DIR_Terminate(				void ) ;														// A[JCufBNgɌĂ鏈̌n
extern	int			DXA_DIR_SetArchiveExtension(	const TCHAR *Extension = NULL ) ;								// A[JCut@C̊gqݒ肷
extern	int			DXA_DIR_SetDXArchivePriority(	int Priority = 0 ) ;											// A[JCut@Cƒʏ̃tH_̂ǂ݂ꍇAǂD悳邩ݒ肷( 1:tH_D 0:cwA[JCut@CD(ftHg) )
extern	int			DXA_DIR_SetKeyString(			const char *KeyString = NULL ) ;								// A[JCut@Čݒ肷
extern	LONGLONG	DXA_DIR_LoadFile(				const TCHAR *FilePath, void *Buffer, int BufferSize ) ;			// t@CۂƓǂݍފ֐

extern	DWORD_PTR	DXA_DIR_Open(					const TCHAR *FilePath, int UseCacheFlag = FALSE, int BlockReadFlag = TRUE, int UseASyncReadFlag = FALSE ) ;	// t@CJ( G[F-1  Fnh )
extern	int			DXA_DIR_Close(					DWORD_PTR Handle ) ;											// t@C
extern	LONGLONG	DXA_DIR_Tell(					DWORD_PTR Handle ) ;											// t@C|C^̈ʒu擾
extern	int			DXA_DIR_Seek(					DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;			// t@C|C^̈ʒuύX
extern	size_t		DXA_DIR_Read(					void *Buffer, size_t BlockSize, size_t BlockNum, DWORD_PTR Handle ) ; // t@Cf[^ǂݍ
extern	int			DXA_DIR_Eof(					DWORD_PTR Handle ) ;											// t@C̏I[𒲂ׂ
extern	int			DXA_DIR_ChDir(					const TCHAR *Path ) ;
extern	int			DXA_DIR_GetDir(					TCHAR *Buffer ) ;
extern	int			DXA_DIR_IdleCheck(				DWORD_PTR Handle ) ;
extern	DWORD_PTR	DXA_DIR_FindFirst(				const TCHAR *FilePath, FILEINFO *Buffer ) ;						// ߂l: -1=G[  -1ȊO=FindHandle
extern	int			DXA_DIR_FindNext(				DWORD_PTR FindHandle, FILEINFO *Buffer ) ;						// ߂l: -1=G[  0=
extern	int			DXA_DIR_FindClose(				DWORD_PTR FindHandle ) ;										// ߂l: -1=G[  0=

#endif

extern	int			DXA_Encode(						void *Src, DWORD SrcSize, void *Dest ) ;						// f[^k( ߂l:k̃f[^TCY )
extern	int			DXA_Decode(						void *Src, void *Dest ) ;										// f[^𓀂( ߂l:𓀌̃f[^TCY )

}

#endif // __DXARCHIVE_H__
