// -------------------------------------------------------------------------------
// 
// 		cwCu		TEhf[^ϊvO
// 
// 				Ver 3.12a
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxSoundConvert.h"
#include "DxStatic.h"

#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxUseCLib.h"

namespace DxLib
{

// }N` --------------------------------------------------------------------

// `NhcZbg}N
#define RIFFCHUNKID( C1 , C2 , C3 , C4 )	( DWORD )( ((( DWORD )C4)<<24) | ((( DWORD )C3)<<16) | ((( DWORD )C2)<<8) | (C1) ) 

#ifndef WAVE_FORMAT_IEEE_FLOAT
#define WAVE_FORMAT_IEEE_FLOAT		0x0003
#endif

#ifndef WAVE_FORMAT_PCM
#define WAVE_FORMAT_PCM				0x0001
#endif

// \̒` --------------------------------------------------------------------

// TEhϊŜŎgpf[^\
struct SOUNDCONVERTDATA
{
	int							InitializeFlag ;				// tO

#ifndef DX_NON_ACM
	HMODULE						msacm32DLL ;					// msacm32DLL
	MMRESULT					( WINAPI *acmStreamOpenFunc )( LPHACMSTREAM phas, HACMDRIVER had, LPWAVEFORMATEX pwfxSrc, LPWAVEFORMATEX pwfxDst, LPWAVEFILTER pwfltr, DWORD dwCallback, DWORD dwInstance, DWORD fdwOpen );
	MMRESULT					( WINAPI *acmFormatSuggestFunc )( HACMDRIVER had, LPWAVEFORMATEX pwfxSrc, LPWAVEFORMATEX pwfxDst, DWORD cbwfxDst, DWORD fdwSuggest );
	MMRESULT					( WINAPI *acmStreamCloseFunc )( HACMSTREAM has, DWORD fdwClose );
	MMRESULT					( WINAPI *acmMetricsFunc )( HACMOBJ hao, UINT uMetric, LPVOID pMetric );
	MMRESULT					( WINAPI *acmStreamPrepareHeaderFunc )( HACMSTREAM has, LPACMSTREAMHEADER pash, DWORD fdwPrepare );
	MMRESULT					( WINAPI *acmStreamConvertFunc )( HACMSTREAM has, LPACMSTREAMHEADER pash, DWORD fdwConvert );
	MMRESULT					( WINAPI *acmStreamUnprepareHeaderFunc )( HACMSTREAM has, LPACMSTREAMHEADER pash, DWORD fdwUnprepare );
	MMRESULT					( WINAPI *acmStreamSizeFunc )( HACMSTREAM has, DWORD cbInput, LPDWORD pdwOutputBytes, DWORD fdwSize );
#endif
} ;

// ϐ錾 --------------------------------------------------------------

// TEhϊŜŎgpf[^
SOUNDCONVERTDATA GSoundConvertData ;

// ֐vg^Cv錾-----------------------------------------------------------

static	int CheckNormalWaveFormat( STREAMDATA *Stream ) ;											// ʏ̂obl`ׂ( TRUE:obl`  FALSE:Ⴄ )

static	int SetupSoundConvert_WAVE(            SOUNDCONV *SoundConv ) ;								// v`udt@C̃ZbgAbvs( [] -1:G[ )
static	int TerminateSoundConvert_WAVE(        SOUNDCONV *SoundConv ) ;								// v`udt@Čns
static	int ConvertProcessSoundConvert_WAVE(   SOUNDCONV *SoundConv ) ;								// ϊ̃obt@Ƀf[^[
//static	int SetTimeSoundConvert_WAVE(      SOUNDCONV *SoundConv, int Time ) ;					// ϊ̈ʒuύX( ~bP )
static	int SetSampleTimeSoundConvert_WAVE(    SOUNDCONV *SoundConv, int SampleTime ) ;				// ϊ̈ʒuύX( TvP )
static	int GetSoundConvertDestSize_Fast_WAVE( SOUNDCONV *SoundConv ) ;								// ϊ̑}̃f[^TCY𓾂

#ifndef DX_NON_ACM
static	int SetupSoundConvert_ACM(            SOUNDCONV *SoundConv ) ;								// `blgpt@C̃ZbgAbvs( [] -1:G[ )
static	int SetupSoundConvert_MP3(            SOUNDCONV *SoundConv ) ;								// loRt@C̃ZbgAbvs( [] -1:G[ )
static	int TerminateSoundConvert_ACM(        SOUNDCONV *SoundConv ) ;								// `blgpt@Čns
static	int ConvertProcessSoundConvert_ACM(   SOUNDCONV *SoundConv ) ;								// ϊ̃obt@Ƀf[^[
//static	int SetTimeSoundConvert_ACM(      SOUNDCONV *SoundConv, int Time ) ;					// ϊʒuύX( ~bP )
static	int SetSampleTimeSoundConvert_ACM(    SOUNDCONV *SoundConv, int SampleTime ) ;				// ϊ̈ʒuύX( TvP )
static	int GetSoundConvertDestSize_Fast_ACM( SOUNDCONV *SoundConv ) ;								// ϊ̑}̃f[^TCY𓾂
#endif

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
static	int TerminateSoundConvert_DSMP3(        SOUNDCONV *SoundConv ) ;							// MP3gpt@Čns
static	int ConvertProcessSoundConvert_DSMP3(   SOUNDCONV *SoundConv ) ;							// ϊ̃obt@Ƀf[^[
//extern	int SetTimeSoundConvert_DSMP3(      SOUNDCONV *SoundConv, int Time ) ;					// ϊʒuύX( ~bP )
static	int SetSampleTimeSoundConvert_DSMP3(    SOUNDCONV *SoundConv, int SampleTime ) ;			// ϊ̈ʒuύX( TvP )
static	int GetSoundConvertDestSize_Fast_DSMP3( SOUNDCONV *SoundConv ) ;							// ϊ̑}̃f[^TCY𓾂
#endif
#endif
#endif

// vO --------------------------------------------------------------------

// EI֐

// TEhf[^ϊ̏s
extern	int InitializeSoundConvert( void )
{
	// ɏς݂̏ꍇ͉Ȃ
	if( GSoundConvertData.InitializeFlag == TRUE )
		return -1 ;

#ifndef DX_NON_ACM
	// MSACM32DLL [h
	if( GSoundConvertData.msacm32DLL == NULL )
	{
		GSoundConvertData.msacm32DLL = LoadLibrary( _T( "msacm32.dll" ) ) ;
		if( GSoundConvertData.msacm32DLL == NULL )
			return -1 ;

		GSoundConvertData.acmFormatSuggestFunc = ( MMRESULT ( WINAPI * )( HACMDRIVER, LPWAVEFORMATEX, LPWAVEFORMATEX, DWORD, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmFormatSuggest" ) ;
		if( GSoundConvertData.acmFormatSuggestFunc == NULL )
			return -1 ;

		GSoundConvertData.acmStreamOpenFunc = ( MMRESULT ( WINAPI * )( LPHACMSTREAM, HACMDRIVER, LPWAVEFORMATEX, LPWAVEFORMATEX, LPWAVEFILTER, DWORD, DWORD, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmStreamOpen" ) ;
		if( GSoundConvertData.acmStreamOpenFunc == NULL )
			return -1 ;

		GSoundConvertData.acmStreamCloseFunc = ( MMRESULT ( WINAPI * )( HACMSTREAM, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmStreamClose" ) ;
		if( GSoundConvertData.acmStreamCloseFunc == NULL )
			return -1 ;

		GSoundConvertData.acmMetricsFunc = ( MMRESULT ( WINAPI * )( HACMOBJ, UINT, LPVOID ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmMetrics" ) ;
		if( GSoundConvertData.acmMetricsFunc == NULL )
			return -1 ;

		GSoundConvertData.acmStreamPrepareHeaderFunc = ( MMRESULT ( WINAPI * )( HACMSTREAM, LPACMSTREAMHEADER, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmStreamPrepareHeader" ) ;
		if( GSoundConvertData.acmStreamPrepareHeaderFunc == NULL )
			return -1 ;

		GSoundConvertData.acmStreamConvertFunc = ( MMRESULT ( WINAPI * )( HACMSTREAM, LPACMSTREAMHEADER, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmStreamConvert" ) ;
		if( GSoundConvertData.acmStreamConvertFunc == NULL )
			return -1 ;

		GSoundConvertData.acmStreamUnprepareHeaderFunc = ( MMRESULT ( WINAPI * )( HACMSTREAM, LPACMSTREAMHEADER, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmStreamUnprepareHeader" ) ;
		if( GSoundConvertData.acmStreamUnprepareHeaderFunc == NULL )
			return -1 ;

		GSoundConvertData.acmStreamSizeFunc = ( MMRESULT  ( WINAPI * )( HACMSTREAM, DWORD, LPDWORD, DWORD ) )GetProcAddress( GSoundConvertData.msacm32DLL, "acmStreamSize" ) ;
		if( GSoundConvertData.acmStreamSizeFunc == NULL )
			return -1 ;
	}
#endif

	// tO𗧂Ă
	GSoundConvertData.InitializeFlag = TRUE ;

	// I
	return 0 ;
}

// TEhf[^ϊ̏Is
extern	int TerminateSoundConvert( void )
{
	// Ɍnς݂̏ꍇ͉Ȃ
	if( GSoundConvertData.InitializeFlag == FALSE )
		return -1 ;

#ifndef DX_NON_ACM
	// msacm32.DLL ̉
	if( GSoundConvertData.msacm32DLL )
	{
		FreeLibrary( GSoundConvertData.msacm32DLL ) ;
		GSoundConvertData.msacm32DLL = NULL ;
		GSoundConvertData.acmFormatSuggestFunc = NULL ;
		GSoundConvertData.acmStreamOpenFunc = NULL ;
		GSoundConvertData.acmStreamCloseFunc = NULL ;
		GSoundConvertData.acmMetricsFunc = NULL ;
		GSoundConvertData.acmStreamPrepareHeaderFunc = NULL ;
		GSoundConvertData.acmStreamConvertFunc = NULL ;
		GSoundConvertData.acmStreamUnprepareHeaderFunc = NULL ;
		GSoundConvertData.acmStreamSizeFunc = NULL ;
	}
#endif

	// tO|
	GSoundConvertData.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// ϊ̃ZbgAbv( [] -1:G[ )
extern	int SetupSoundConvert( SOUNDCONV *SoundConv, STREAMDATA *Stream, int DisableReadSoundFunctionMask, int OggVorbisBitDepth, int OggVorbisFromTheoraFile )
{
	// 
#ifndef DX_NON_OGGVORBIS
	SoundConv->OggVorbisBitDepth = OggVorbisBitDepth ;
	SoundConv->OggVorbisFromTheoraFile = OggVorbisFromTheoraFile ;
#endif
	SoundConv->Stream = *Stream ;
	SoundConv->SeekLockPosition = 0 ;
	Stream->ReadShred.Seek( Stream->DataPoint, 0, SEEK_SET ) ;
	if( ( DisableReadSoundFunctionMask & DX_READSOUNDFUNCTION_PCM ) == 0 )
	{
		if( SetupSoundConvert_WAVE( SoundConv ) == 0 ) goto R1 ;
		Stream->ReadShred.Seek( Stream->DataPoint, 0, SEEK_SET ) ;
	}
#ifndef DX_NON_ACM
	if( ( DisableReadSoundFunctionMask & DX_READSOUNDFUNCTION_ACM ) == 0 )
	{
		if( SetupSoundConvert_ACM( SoundConv ) == 0 ) goto R1 ;
		Stream->ReadShred.Seek( Stream->DataPoint, 0, SEEK_SET ) ;
	}
#endif
#ifndef DX_NON_OGGVORBIS
	if( ( DisableReadSoundFunctionMask & DX_READSOUNDFUNCTION_OGG ) == 0 )
	{
		if( SetupSoundConvert_OGG( SoundConv ) == 0 ) goto R1 ;
		Stream->ReadShred.Seek( Stream->DataPoint, 0, SEEK_SET ) ;
	}
#endif
#ifndef DX_NON_ACM
	if( ( DisableReadSoundFunctionMask & DX_READSOUNDFUNCTION_MP3 ) == 0 )
	{
		if( SetupSoundConvert_MP3( SoundConv ) == 0 ) goto R1 ;
	}
#endif
#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
	if( ( DisableReadSoundFunctionMask & DX_READSOUNDFUNCTION_DSMP3 ) == 0 )
	{
		if( SetupSoundConvert_DSMP3( SoundConv ) == 0 ) goto R1 ;
	}
#endif
#endif
#endif
	return -1 ;
	
R1 :
	// ʏs
	SoundConv->InitializeFlag = FALSE ;
	SoundConv->EndFlag = FALSE ;
	SoundConv->DestData = DXALLOC( SoundConv->DestDataSize ) ;
	if( SoundConv->DestData == NULL )
	{
		TerminateSoundConvert( SoundConv ) ;
		return -1 ;
	}
	SoundConv->DestDataValidSize = 0 ;
	SoundConv->DestDataCompSize = 0 ;
	SoundConv->DestDataCompSizeAll = 0 ;

	// 
	SoundConv->InitializeFlag = TRUE ;
	
	// I
	return 0 ;
}

/*
// ϊԂɖ߂
extern	int SetTimeSoundConvert( SOUNDCONV *SoundConv, int Time )
{
	int res ;
	int BytePos ;

	BytePos = ( SoundConv->OutFormat.nSamplesPerSec * Time / 1000 ) * SoundConv->OutFormat.nBlockAlign ;
	if( _ABS( BytePos - SoundConv->DestDataCompSizeAll ) < 16 ) return 0 ;

	switch( SoundConv->MethodType )
	{
	case SOUND_METHODTYPE_NORMAL : res = SetTimeSoundConvert_WAVE( SoundConv, Time ) ; break ;
#ifndef DX_NON_ACM
	case SOUND_METHODTYPE_ACM : res = SetTimeSoundConvert_ACM( SoundConv, Time ) ; break ;
#endif
#ifndef DX_NON_OGGVORBIS
	case SOUND_METHODTYPE_OGG : res = SetTimeSoundConvert_OGG( SoundConv, Time ) ; break ;
#endif
	}
	SoundConv->EndFlag = FALSE ;
	return res ;
}
*/

// ϊ̈ʒuύX( TvP )
extern int SetSampleTimeSoundConvert( SOUNDCONV *SoundConv, int SampleTime )
{
	int res = -1 ;
	int BytePos ;

	BytePos = SampleTime * SoundConv->OutFormat.nBlockAlign ;
	if( _ABS( BytePos - SoundConv->DestDataCompSizeAll ) < 16 ) return 0 ;

	switch( SoundConv->MethodType )
	{
	case SOUND_METHODTYPE_NORMAL : res = SetSampleTimeSoundConvert_WAVE( SoundConv, SampleTime ) ; break ;
#ifndef DX_NON_ACM
	case SOUND_METHODTYPE_ACM : res = SetSampleTimeSoundConvert_ACM( SoundConv, SampleTime ) ; break ;
#endif
#ifndef DX_NON_OGGVORBIS
	case SOUND_METHODTYPE_OGG : res = SetSampleTimeSoundConvert_OGG( SoundConv, SampleTime ) ; break ;
#endif
#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
	case SOUND_METHODTYPE_DSMP3 : res = SetSampleTimeSoundConvert_DSMP3( SoundConv, SampleTime ) ; break ;
#endif
#endif
#endif
	}
	SoundConv->EndFlag = FALSE ;
	return res ;
}

// V[N\̈ʒuZbgĂ(`blׂ̈)
extern	int SetupSeekPosSoundConvert( SOUNDCONV *SoundConv, int SeekPos )
{
	SoundConv->SeekLockPosition = SeekPos * SoundConv->OutFormat.nBlockAlign ;

	return 0 ;
}


// w̃TCY( [] -1:G[  0ȏ:ϊTCY )
extern	int RunSoundConvert( SOUNDCONV *SoundConv, void *DestBuffer, int DestSize )
{
	int pos, movesize, res = -1, copysize ;
	
	if( SoundConv->InitializeFlag == FALSE ) return -1 ;
	if( SoundConv->EndFlag == TRUE ) return 0 ;
	
	pos = 0 ;
	copysize = 0 ;
	while( DestSize != 0 )
	{
		if( SoundConv->DestDataValidSize == 0 )
		{
			SoundConv->DestDataCompSize = 0 ;
			switch( SoundConv->MethodType )
			{
			case SOUND_METHODTYPE_NORMAL : res = ConvertProcessSoundConvert_WAVE( SoundConv ) ; break ;
#ifndef DX_NON_ACM
			case SOUND_METHODTYPE_ACM : res = ConvertProcessSoundConvert_ACM( SoundConv ) ; break ;
#endif
#ifndef DX_NON_OGGVORBIS
			case SOUND_METHODTYPE_OGG : res = ConvertProcessSoundConvert_OGG( SoundConv ) ; break ;
#endif
#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
			case SOUND_METHODTYPE_DSMP3 : res = ConvertProcessSoundConvert_DSMP3( SoundConv ) ; break ;
#endif
#endif
#endif
			}
			if( res == -1 ) break ;
		}
	
		movesize = DestSize ;
		if( movesize > SoundConv->DestDataValidSize ) movesize = SoundConv->DestDataValidSize ;
/*
		int i ;
		int tmp ;
		short *dst, *src ;

		for( i = 0 ; i < movesize / 4 ; i ++ )
		{
			dst = ( short * )( (BYTE *)DestBuffer + pos + i * 4 ) ;
			src = ( short * )( (BYTE *)SoundConv->DestData + SoundConv->DestDataCompSize + i * 4 ) ;

			tmp = src[ 0 ] * 3 / 2 ;
			if( tmp >  32767 ) tmp =  32767 ;
			if( tmp < -32768 ) tmp = -32768 ;
			dst[ 0 ] = ( short )tmp ;

//			NS_DrawPixel( i, ( tmp + 32768 ) / 256, GetColor( 255,255,255 ) ) ;

			tmp = src[ 1 ] * 3 / 2 ;
			if( tmp >  32767 ) tmp =  32767 ;
			if( tmp < -32768 ) tmp = -32768 ;
			dst[ 1 ] = ( short )tmp ;
		}
//		NS_ScreenFlip() ;
//		WaitKey() ;
*/
		_MEMCPY( (BYTE *)DestBuffer + pos,
				(BYTE *)SoundConv->DestData + SoundConv->DestDataCompSize,
				movesize ) ;
		SoundConv->DestDataValidSize -= movesize ;
		SoundConv->DestDataCompSize += movesize ;
		SoundConv->DestDataCompSizeAll += movesize ;
		
		DestSize -= movesize ;
		pos += movesize ;
		copysize += movesize ;
	}
	if( DestSize != 0 )
	{
		SoundConv->EndFlag = TRUE ;
	}

	// I
	return copysize ;
}

// ϊ̌ns
extern	int TerminateSoundConvert( SOUNDCONV *SoundConv )
{
	if( SoundConv->InitializeFlag == FALSE ) return -1 ;
	
	if( SoundConv->DestData != NULL )
	{
		DXFREE( SoundConv->DestData ) ;
		SoundConv->DestData = NULL ;
	}
	
	switch( SoundConv->MethodType )
	{
	case SOUND_METHODTYPE_NORMAL : TerminateSoundConvert_WAVE( SoundConv ) ; break ;
#ifndef DX_NON_ACM
	case SOUND_METHODTYPE_ACM : TerminateSoundConvert_ACM( SoundConv ) ; break ;
#endif
#ifndef DX_NON_OGGVORBIS
	case SOUND_METHODTYPE_OGG : TerminateSoundConvert_OGG( SoundConv ) ; break ;
#endif
#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
	case SOUND_METHODTYPE_DSMP3 : TerminateSoundConvert_DSMP3( SoundConv ) ; break ;
#endif
#endif
#endif
	}

	SoundConv->InitializeFlag = FALSE ;
	
	// I
	return 0 ;	
}

// ϊ̉`擾( [] -1:G[  0ȏ:ϊ̃TCY )
extern	int GetOutSoundFormatInfo( SOUNDCONV *SoundConv, WAVEFORMATEX *OutWaveFormat )
{
	*OutWaveFormat = SoundConv->OutFormat ;
	return 0 ;
}

// ϊ̉`擾( [] -1:G[  0ȏ:ϊ̃TCY )
extern	int GetOutSoundFormat( SOUNDCONV *SoundConv, WAVEFORMATEX *OutWaveFormat )
{
	*OutWaveFormat = SoundConv->OutFormat ;
	
	return 0 ;
}

// ϊIĂ邩ǂ擾( [] TRUE:I  FALSE:܂IĂȂ )
extern	int GetSoundConvertEndState( SOUNDCONV *SoundConv )
{
	return SoundConv->EndFlag ;
}

// ϊ̑}̃f[^TCY𓾂
extern	int GetSoundConvertDestSize_Fast( SOUNDCONV *SoundConv )
{
	switch( SoundConv->MethodType )
	{
	case SOUND_METHODTYPE_NORMAL : return GetSoundConvertDestSize_Fast_WAVE( SoundConv ) ; break ;
#ifndef DX_NON_ACM
	case SOUND_METHODTYPE_ACM : return GetSoundConvertDestSize_Fast_ACM( SoundConv ) ; break ;
#endif
#ifndef DX_NON_OGGVORBIS
	case SOUND_METHODTYPE_OGG : return GetSoundConvertDestSize_Fast_OGG( SoundConv ) ; break ;
#endif
#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3
	case SOUND_METHODTYPE_DSMP3 : return GetSoundConvertDestSize_Fast_DSMP3( SoundConv ) ; break ;
#endif
#endif
#endif
	}
	return 0 ;
}

//extern void *SoundBuf ;
//extern int SoundSize ;

// Ȉꊇϊ
extern	int SoundConvertFast( SOUNDCONV *SoundConv, 
									WAVEFORMATEX *FormatP, void **DestBufferP, int *DestSizeP )
{
	void *Buffer ;
	int BufferSize ;

	// obt@̊m
	BufferSize = GetSoundConvertDestSize_Fast( SoundConv ) ;

	Buffer = DXALLOC( BufferSize ) ;
	if( Buffer == NULL ) return -1 ;
	
	// ϊʒũZbg
//	SetTimeSoundConvert( SoundConv, 0 ) ;
	SetSampleTimeSoundConvert( SoundConv, 0 ) ;


	// f[^`kobl̏ꍇ݂̂̂܂܃Rs[
	if( SoundConv->MethodType == SOUND_METHODTYPE_NORMAL &&
		( ( SOUNDCONV_WAVE * )SoundConv->ConvFunctionBuffer )->SrcFormat.wFormatTag == WAVE_FORMAT_PCM )
	{
		SoundConv->Stream.ReadShred.Read( Buffer, BufferSize, 1, SoundConv->Stream.DataPoint ) ;
	}
	else
	{
		// ȊȌꍇ͕ʂɓWJ
		BufferSize = RunSoundConvert( SoundConv, Buffer, BufferSize ) ;
	}

	// ۑ
	*FormatP = SoundConv->OutFormat ;
	*DestBufferP = Buffer ;
	*DestSizeP = BufferSize ;
	
	// I
	return 0 ;
}















// tH[}bgϊp

// ʏ̂obl`ׂ( TRUE:obl`  FALSE:Ⴄ )
extern	int CheckNormalWaveFormat( STREAMDATA *Stream )
{
	___RIFFCHUNK chunk ;
	char type[5] ;
	WAVEFORMAT format ;

	// RIFFt@Cǂׂ
	Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
	if( chunk.fcc != RIFFCHUNKID( 'R', 'I', 'F', 'F' ) )
		return FALSE ;
		
	// WAVEt@Cǂׂ
	type[4] = '\0' ;
	Stream->ReadShred.Read( type, 4, 1, Stream->DataPoint ) ;
	if( _STRCMP( type, "WAVE" ) != 0 )
		return FALSE ;
		
	// m[}Ȃobl`ׂ
	Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
	if( chunk.fcc != RIFFCHUNKID( 'f', 'm', 't', ' ' ) )
		return FALSE ;

	Stream->ReadShred.Read( &format, sizeof( WAVEFORMAT ), 1, Stream->DataPoint ) ;
	if( format.wFormatTag != WAVE_FORMAT_PCM )
		return FALSE ;
		
	// ܂ŗʏ̃tH[}bgƂ
	return TRUE ;
}

// v`udt@C̃ZbgAbvs( [] -1:G[ )
static	int SetupSoundConvert_WAVE( SOUNDCONV *SoundConv )
{
	___RIFFCHUNK chunk ;
	char type[5] ;
	WAVEFORMATEX *format = NULL ;
	STREAMDATA *Stream = &SoundConv->Stream ;
	SOUNDCONV_WAVE *Wave = ( SOUNDCONV_WAVE * )SoundConv->ConvFunctionBuffer ;

	Wave->SrcBuffer = NULL ;

	// RIFFt@Cǂׂ
	Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
	if( chunk.fcc != RIFFCHUNKID( 'R', 'I', 'F', 'F' ) )
		goto ERR ;

	// WAVEt@Cǂׂ
	type[4] = '\0' ;
	Stream->ReadShred.Read( type, 4, 1, Stream->DataPoint ) ;
	if( _STRCMP( type, "WAVE" ) != 0 )
		goto ERR ;

	// m[}Ȃobl`ׂ
	{
		// g񂪂XLbv
		Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
		if( chunk.fcc == RIFFCHUNKID( 'b', 'e', 'x', 't' ) )
		{
			Stream->ReadShred.Seek( Stream->DataPoint, chunk.cb, SEEK_CUR ) ;
			Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
		}
		if( chunk.fcc != RIFFCHUNKID( 'f', 'm', 't', ' ' ) )
			goto ERR ;

		format = (WAVEFORMATEX *)DXALLOC( chunk.cb ) ;
		if( format == NULL ) goto ERR ;

		// wb_̈ʒuƃTCYZbg
		SoundConv->HeaderPos = ( int )Stream->ReadShred.Tell( Stream->DataPoint ) ;
		SoundConv->HeaderSize = chunk.cb ;

		_MEMSET( SoundConv->ConvFunctionBuffer, 0, sizeof( SoundConv->ConvFunctionBuffer ) ) ;

		_MEMSET( &SoundConv->OutFormat, 0, sizeof( SoundConv->OutFormat ) ) ;
		Stream->ReadShred.Read( format, chunk.cb, 1, Stream->DataPoint ) ;
		switch( format->wFormatTag )
		{
		case WAVE_FORMAT_PCM :

			// ` WAVEFORMATEX ł͂Ȃꍇ͕⊮
			_MEMCPY( &SoundConv->OutFormat, format, chunk.cb ) ;
			if( chunk.cb == 16 )
			{
				SoundConv->OutFormat.wBitsPerSample = format->nBlockAlign / format->nChannels * 8 ;
				SoundConv->OutFormat.cbSize = 0 ;
			}
			break ;


		case WAVE_FORMAT_IEEE_FLOAT :

			// o̓tH[}bgZbg
			SoundConv->OutFormat.nSamplesPerSec = format->nSamplesPerSec ;
			SoundConv->OutFormat.nChannels = format->nChannels ;
			SoundConv->OutFormat.wBitsPerSample = 16 ;
			SoundConv->OutFormat.wFormatTag = WAVE_FORMAT_PCM ;
			SoundConv->OutFormat.nBlockAlign = SoundConv->OutFormat.wBitsPerSample  * SoundConv->OutFormat.nChannels / 8 ;
			SoundConv->OutFormat.nAvgBytesPerSec = SoundConv->OutFormat.nBlockAlign * SoundConv->OutFormat.nSamplesPerSec ;

			Wave->SrcSampleNum = SoundConv->OutFormat.nSamplesPerSec ;
			Wave->SrcBufferSize = format->nAvgBytesPerSec ;
			Wave->SrcBuffer = ( BYTE * )DXALLOC( Wave->SrcBufferSize ) ;
			if( Wave->SrcBuffer == NULL )
				goto ERR ;
			break ;


		default :
			goto ERR ;
		}

		// tH[}bg̃Rs[
		_MEMCPY( &Wave->SrcFormat, format, chunk.cb ) ;

		// ̉
		DXFREE( format ) ;
		format = NULL ;
	}

	// f[^`NT
	while( Stream->ReadShred.Eof( Stream->DataPoint ) == 0 )
	{
		Stream->ReadShred.Read( &chunk , sizeof( chunk ) , 1 , Stream->DataPoint ) ;
		if( chunk.fcc == RIFFCHUNKID( 'd', 'a', 't', 'a' ) ) break ;
		Stream->ReadShred.Seek( Stream->DataPoint, chunk.cb + ( ( chunk.cb % 2 != 0 ) ? 1 : 0 ) , SEEK_CUR ) ; 
	}
	if( Stream->ReadShred.Eof( Stream->DataPoint ) != 0 )
		goto ERR ;

	SoundConv->DataPos = ( int )Stream->ReadShred.Tell( Stream->DataPoint ) ;
	SoundConv->DataSize = ( int )chunk.cb ;

	// ϊ̂oblf[^ꎞIɕۑ郁̈̃TCYZbg
	SoundConv->DestDataSize = SoundConv->OutFormat.nAvgBytesPerSec ;

	// ^CvZbg
	SoundConv->MethodType = SOUND_METHODTYPE_NORMAL ;

	// I
	return 0 ;

ERR :
	if( Wave->SrcBuffer != NULL )
	{
		DXFREE( Wave->SrcBuffer ) ;
		Wave->SrcBuffer = NULL ;
	}

	if( format != NULL )
	{
		DXFREE( format ) ;
		format = NULL ;
	}

	return -1 ;
}

#ifndef DX_NON_ACM

#ifdef DX_GCC_COMPILE
#define ACM_FORMATSUGGESTF_WFORMATTAG       0x00010000L
#define ACM_FORMATSUGGESTF_NCHANNELS        0x00020000L
#define ACM_FORMATSUGGESTF_NSAMPLESPERSEC   0x00040000L
#define ACM_FORMATSUGGESTF_WBITSPERSAMPLE   0x00080000L

#define ACM_STREAMOPENF_QUERY           0x00000001
#define ACM_STREAMOPENF_ASYNC           0x00000002
#define ACM_STREAMOPENF_NONREALTIME     0x00000004
#endif

// `blt@C̃ZbgAbvs( [] -1:G[ )
static	int SetupSoundConvert_ACM( SOUNDCONV *SoundConv )
{
	___RIFFCHUNK chunk ;
	char type[5] ;
	STREAMDATA *Stream = &SoundConv->Stream ;
//	SOUNDCONV_ACM *acmdata = &SoundConv->AcmTypeData ;
	SOUNDCONV_ACM *acmdata = (SOUNDCONV_ACM *)SoundConv->ConvFunctionBuffer ;
	int res, i ;
	
	acmdata->Format = NULL ;
	acmdata->AcmStreamHandle[0] = NULL ;
	acmdata->AcmStreamHandle[1] = NULL ;
	acmdata->SrcData = NULL ;
	acmdata->DestDataSampleNum = -1 ;
	acmdata->BeginSeekPosition = 0 ;
	acmdata->BeginSeekCompSrcSize = 0 ;
	acmdata->BeginSeekBuffer = NULL ;

	// RIFFt@Cǂׂ
	Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
	if( chunk.fcc != RIFFCHUNKID( 'R', 'I', 'F', 'F' ) )
		goto ERR ;

	// WAVEt@Cǂׂ
	type[4] = '\0' ;
	Stream->ReadShred.Read( type, 4, 1, Stream->DataPoint ) ;
	if( _STRCMP( type, "WAVE" ) != 0 )
		goto ERR ;

	// tH[}bg擾
	{
		// g񂪂XLbv
		Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
		if( chunk.fcc == RIFFCHUNKID( 'b', 'e', 'x', 't' ) )
		{
			Stream->ReadShred.Seek( Stream->DataPoint, chunk.cb, SEEK_CUR ) ;
			Stream->ReadShred.Read( &chunk, sizeof( chunk ), 1, Stream->DataPoint ) ;
		}
		if( chunk.fcc != RIFFCHUNKID( 'f', 'm', 't', ' ' ) ) goto ERR ;

		acmdata->Format = (WAVEFORMATEX *)DXALLOC( chunk.cb ) ;
		if( acmdata->Format == NULL ) goto ERR ;

		// wb_̈ʒuƃTCYZbg
		SoundConv->HeaderPos = ( int )Stream->ReadShred.Tell( Stream->DataPoint ) ;
		SoundConv->HeaderSize = chunk.cb ;

		Stream->ReadShred.Read( acmdata->Format, chunk.cb, 1, Stream->DataPoint ) ;

		// ` WAVEFORMATEX ł͂Ȃꍇ͕⊮
		if( acmdata->Format->wFormatTag == WAVE_FORMAT_PCM && chunk.cb == 16 )
		{
			acmdata->Format->wBitsPerSample = acmdata->Format->nBlockAlign / acmdata->Format->nChannels * 8 ;
			acmdata->Format->cbSize = 0 ;
		}
	}
	
	// f[^`NT
	while( Stream->ReadShred.Eof( Stream->DataPoint ) == 0 )
	{
		Stream->ReadShred.Read( &chunk , sizeof( chunk ) , 1 , Stream->DataPoint ) ;
		if( chunk.fcc == RIFFCHUNKID( 'd', 'a', 't', 'a' ) ) break ;
		Stream->ReadShred.Seek( Stream->DataPoint, chunk.cb + ( ( chunk.cb % 2 != 0 ) ? 1 : 0 ) , SEEK_CUR ) ; 
	}
	
	if( Stream->ReadShred.Eof( Stream->DataPoint ) != 0 )
		goto ERR ;

	// f[^`N̏Zbg
	SoundConv->DataPos = ( int )Stream->ReadShred.Tell( Stream->DataPoint ) ;
	SoundConv->DataSize = chunk.cb ;

	// ϊ̐tH[}bg𓾂
	_MEMSET( &SoundConv->OutFormat, 0, sizeof( SoundConv->OutFormat ) ) ;
	SoundConv->OutFormat.wFormatTag = WAVE_FORMAT_PCM ;
	res = GSoundConvertData.acmFormatSuggestFunc( NULL, acmdata->Format, &SoundConv->OutFormat, sizeof( WAVEFORMATEX ), ACM_FORMATSUGGESTF_WFORMATTAG ) ;
	if( res != 0 ) goto ERR ;
	
	// kf[^ꎞIɕۑ郁̈̊m
//	acmdata->SrcDataSize = AdjustSoundDataBlock( acmdata->Format->nAvgBytesPerSec / STS_CACHEBUFFERSEC, acmdata->Format ) ;
	acmdata->SrcDataSize = SoundConv->DataSize ;  // [v̊֌WŁAہXf[^܂̈mۂ
	acmdata->SrcData = DXALLOC( acmdata->SrcDataSize ) ;
	if( acmdata->SrcData == NULL ) goto ERR ;
//	acmdata->SrcDataValidSize = 0 ;
	acmdata->SrcDataPosition = 0 ;

	// kf[^ꊇœǂݍ
	Stream->ReadShred.Read( acmdata->SrcData, SoundConv->DataSize, 1, Stream->DataPoint ) ;
	Stream->ReadShred.Seek( Stream->DataPoint, SoundConv->DataPos, STREAM_SEEKTYPE_SET ) ;
//	acmdata->SrcDataValidSize = SoundConv->DataSize ;
	
	// `blnh̍쐬
	for( i = 0 ; i < 2 ; i ++ )
	{
		res = GSoundConvertData.acmStreamOpenFunc( &acmdata->AcmStreamHandle[i],
								NULL,
								acmdata->Format,
								&SoundConv->OutFormat,
								NULL,
								0,
								0,
								ACM_STREAMOPENF_NONREALTIME ) ;
		if( res != 0 ) goto ERR ;
	}

	// ϊ̂oblf[^ꎞIɕۑ郁̈̃TCYZbg
	SoundConv->DestDataSize = SoundConv->OutFormat.nAvgBytesPerSec ;

	// V[N\ʒu܂ŕϊĂŎgp郁̈̊m
	acmdata->BeginSeekBuffer = DXALLOC( SoundConv->DestDataSize ) ;
	if( acmdata->BeginSeekBuffer == NULL ) goto ERR ;

	// ^CvZbg
	SoundConv->MethodType = SOUND_METHODTYPE_ACM ;

	// I
	return 0 ;

ERR :
	if( acmdata->AcmStreamHandle[0] != NULL )
	{
		GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[0], 0 ) ;
		acmdata->AcmStreamHandle[0] = NULL ;
	}

	if( acmdata->AcmStreamHandle[1] != NULL )
	{
		GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[1], 0 ) ;
		acmdata->AcmStreamHandle[1] = NULL ;
	}

	if( acmdata->BeginSeekBuffer != NULL )
	{
		DXFREE( acmdata->BeginSeekBuffer ) ;
		acmdata->BeginSeekBuffer = NULL ;
	}

	if( acmdata->Format != NULL )
	{
		DXFREE( acmdata->Format ) ;
		acmdata->Format = NULL ;
	}

	if( acmdata->SrcData != NULL )
	{
		DXFREE( acmdata->SrcData ) ;
		acmdata->SrcData = NULL ;
	}
	
	return -1 ;
}

#endif


#ifndef DX_NON_ACM

// loR̃wb_t@C쐬ƂɕKvȃf[^̒`

// rbg[g̎擾
int MP3BitRateTable[2][3][14] =
{
	// lodf|P
	{
		// Layer-1
		32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448,

		// Layer-2
		32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 384,

		// Layer-3
		32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320,
	},

	// lodf|Q
	{
		// Layer-1
		32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256,

		// Layer-2
		8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 114, 160,

		// Later-3
		8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 114, 160,
	},
};

// TvOg
int MP3FreqTable[2][3] =
{
	// lodf|P
	44100,48000,32000,

	// lodf|Q
	22050,24000,16000,
};

// t[wb_\
struct MP3_FRAMEHEADER
{
	BYTE Layer ;			// 0:Layer-1 1:Layer-2 2:Layer-3
	BYTE MpegV ;			// 0:MPEG1 1:MPEG2
	BYTE BitRateIndex ;
	BYTE SampleRateIndex ;
	BYTE PaddingBit ;
	BYTE ChannelNum ;
	DWORD SampleRate ;
	DWORD BitRate ;
	DWORD FrameSize ;
	DWORD SampleNum ;
} ;

static int AnalysisMP3_FrameHeader( BYTE *Header, MP3_FRAMEHEADER *FrHead )
{
	// loRf[^ׂ
	if( Header[0] != 0xff || ( Header[1] & 0xf0 ) != 0xf0 ) return -2 ;

	// lodf̃o[W𓾂(0:Ver1 1:Ver2)
	FrHead->MpegV = ( Header[1] & 0x8 ) == 0x8 ? 0 : 1 ;

	// C𓾂(0:Layer-1 1:Layer-2 2:Layer-3)
	FrHead->Layer = 3 - ( ( Header[1] >> 1 ) & 0x3 ) ;
	if( FrHead->Layer > 2 ) return -1 ;

	// rbg[g̃CfbNXl𓾂
	FrHead->BitRateIndex = ( Header[2] >> 4 ) & 0xf ;
	if( FrHead->BitRateIndex > 14 ) return -1 ;

	// rbg[g𓾂
	FrHead->BitRate = MP3BitRateTable[FrHead->MpegV][FrHead->Layer][FrHead->BitRateIndex-1] ;

	// TvOg̃CfbNXl𓾂
	FrHead->SampleRateIndex = ( Header[2] >> 2 ) & 0x3 ;
	if( FrHead->SampleRateIndex > 2 ) return -1 ;

	// TvOg𓾂
	FrHead->SampleRate = MP3FreqTable[FrHead->MpegV][FrHead->SampleRateIndex] ;

	// pfBOrbg𓾂
	FrHead->PaddingBit = ( Header[2] >> 1 ) & 1 ;

	// `l[h`l𓾂
	FrHead->ChannelNum = ( ( Header[3] >> 6 ) & 0x3 ) == 3 ? 1 : 2 ;
	
	// t[TCYvZ
	switch( FrHead->MpegV )
	{
	case 0 : // Mapg-1
		switch( FrHead->Layer )
		{
		case 0 :		// Layer-1
			FrHead->FrameSize = ( ( 12 * ( FrHead->BitRate * 1000 ) / FrHead->SampleRate ) + FrHead->PaddingBit ) * 4 ;
			FrHead->SampleNum = 12 * 8 ;
			break ;
			
		case 1 :		// Layer-2 Layer-3
		case 2 :
			FrHead->FrameSize = ( 144 * ( FrHead->BitRate * 1000 ) / FrHead->SampleRate ) + FrHead->PaddingBit ;
			FrHead->SampleNum = 144 * 8 ;
			break ;
		}
		break ;

	case 1 : // Mapg-2
		switch( FrHead->Layer )
		{
		case 0 :		// Layer-1
			FrHead->FrameSize = ( ( 12 * ( FrHead->BitRate * 1000 ) / FrHead->SampleRate ) + FrHead->PaddingBit ) * 4 ;
			FrHead->SampleNum = 12 * 8 ;
			break ;

		case 1 :		// Layer-2 Layer-3
		case 2 :
			FrHead->FrameSize = ( 72 * ( FrHead->BitRate * 1000 ) / FrHead->SampleRate ) + FrHead->PaddingBit ;
			FrHead->SampleNum = 72 * 8 ;
			break ;
		}
		break ;
	}

	// I	
	return 0 ;
}

// loRt@C̃ZbgAbvs( [] -1:G[ )
static int SetupSoundConvert_MP3( SOUNDCONV *SoundConv )
{
	BYTE Header[4] ;
//	BYTE Layer, MpegV, BitRateIndex, SampleRateIndex ;
//	BYTE PaddingBit, ChannelNum ;
//	DWORD SampleRate, BitRate, FrameSize ;
	MPEGLAYER3WAVEFORMAT *MP3Format = NULL ;
	MP3_FRAMEHEADER MP3Frame ;
	int DataSize, FileSize, /*StartPoint,*/ res, i;
	DWORD LastPoint ;
	DWORD SkipSize, EndSkipSize, StartPos ;
//	SOUNDCONV_ACM *acmdata = &SoundConv->AcmTypeData ;
	SOUNDCONV_ACM *acmdata = (SOUNDCONV_ACM *)SoundConv->ConvFunctionBuffer ;
	STREAMDATA *Stream = &SoundConv->Stream ;
	

	acmdata->Format = NULL ;
	acmdata->SrcData = NULL ;
	acmdata->DestDataSampleNum = 0 ;
	acmdata->BeginSeekPosition = 0 ;
	acmdata->BeginSeekCompSrcSize = 0 ;

	// t@CTCY𓾂
	Stream->ReadShred.Seek( Stream->DataPoint, 0, STREAM_SEEKTYPE_END ) ;
	FileSize = ( int )Stream->ReadShred.Tell( Stream->DataPoint ) ;
	Stream->ReadShred.Seek( Stream->DataPoint, 0, STREAM_SEEKTYPE_SET ) ;

	// ID3v2 ^Oꍇ̃XLbvs
	{
		char Tag[4] ;
		BYTE MainVer, SubVer, Flag, SizeData[4] ;

		Tag[3] = '\0' ;
		Stream->ReadShred.Read( Tag, 1, 3, Stream->DataPoint ) ;
		if( _STRCMP( Tag, "ID3" ) == 0 )
		{
			// o[W𓾂
			Stream->ReadShred.Read( &MainVer, 1, 1, Stream->DataPoint ) ;
			Stream->ReadShred.Read( &SubVer, 1, 1, Stream->DataPoint ) ;

			// tO𓾂
			Stream->ReadShred.Read( &Flag, 1, 1, Stream->DataPoint ) ;

			// eʏ𓾂
			Stream->ReadShred.Read( SizeData, 1, 4, Stream->DataPoint ) ;
			SkipSize = ( SizeData[0] << 21 ) + ( SizeData[1] << 14 ) + ( SizeData[2] << 7 ) + SizeData[3] + 10 ;

			// tb^񂪂ꍇ͍XɂPOoCg؂
			if( MainVer == 4 && ( Flag & 0x10 ) != 0 ) SkipSize += 10 ;
		}
		else
		{
			SkipSize = 0 ;
		}
	}

	// t@C̏I[𒲂ׂB ID3v1 ^O邩ǂŕω
	if( FileSize > 128 )
	{
		char Tag[4] ;

		Tag[3] = '\0' ;
		Stream->ReadShred.Seek( Stream->DataPoint, -128, STREAM_SEEKTYPE_END ) ;
		Stream->ReadShred.Read( Tag, 1, 3, Stream->DataPoint ) ;

		if( _STRCMP( Tag, "TAG" ) == 0 )
		{
			EndSkipSize = 128 ;
		}
		else
		{
			EndSkipSize = 0 ;
		}
	}

	// f[^̖[
	{
		// V[N
		Stream->ReadShred.Seek( Stream->DataPoint, SkipSize, STREAM_SEEKTYPE_SET ) ;

		StartPos = 0xffffffff ;

		i = 0;
		for(;;)
		{
			for(;;)
			{
				if( Stream->ReadShred.Read( &Header[0], 1, 1, Stream->DataPoint ) == 0 ) goto R1 ;
				if( Header[0] == 0xff )
				{
					if( Stream->ReadShred.Read( &Header[1], 1, 1, Stream->DataPoint ) == 0 ) goto R1 ;
					if( ( Header[1] & 0xf0 ) == 0xf0 )
					{
						break ;
					}
				}
			}
			
			// c̃wb_ǂݍ
			Stream->ReadShred.Read( &Header[2], 1, 2, Stream->DataPoint ) ;

			// wb_
			if( AnalysisMP3_FrameHeader( Header, &MP3Frame ) < 0 ) return -1 ;

			// t[TCY0G[
			if( MP3Frame.FrameSize <= 0 ) return -1 ;

			// ŏ̃t[ʒuۑĂ
			if( StartPos == 0xffffffff )
			{
				StartPos = ( DWORD )Stream->ReadShred.Tell( Stream->DataPoint ) - 4 ;
			}
/*
			// loRf[^ׂ
			if( Header[0] != 0xff || ( Header[1] & 0xf0 ) != 0xf0 ) continue ;

			// lodf̃o[W𓾂(0:Ver1 1:Ver2)
			MpegV = ( Header[1] & 0x8 ) == 0x8 ? 0 : 1 ;

			// C𓾂(0:Layer-1 1:Layer-2 2:Layer-3)
			Layer = 3 - ( ( Header[1] >> 1 ) & 0x3 ) ;
			if( Layer > 2 ) return -1 ;

			// rbg[g̃CfbNXl𓾂
			BitRateIndex = ( Header[2] >> 4 ) & 0xf ;
			if( BitRateIndex > 14 ) return -1 ;

			// rbg[g𓾂
			BitRate = MP3BitRateTable[MpegV][Layer][BitRateIndex-1] ;

			// TvOg̃CfbNXl𓾂
			SampleRateIndex = ( Header[2] >> 2 ) & 0x3 ;
			if( SampleRateIndex > 2 ) return -1 ;

			// TvOg𓾂
			SampleRate = MP3FreqTable[MpegV][SampleRateIndex] ;

			// pfBOrbg𓾂
			PaddingBit = ( Header[2] >> 1 ) & 1 ;

			// `l[h`l𓾂
			ChannelNum = ( ( Header[3] >> 6 ) & 0x3 ) == 3 ? 1 : 2 ;
			
			// ŏ̃t[ʒuۑĂ
			if( StartPos == 0xffffffff )
			{
				StartPos = Stream->ReadShred.Tell( Stream->DataPoint ) - 4 ;
			}

			// t[TCYvZ
			switch( MpegV )
			{
			case 0 : // Mapg-1
				switch( Layer )
				{
				case 0 : FrameSize = ( ( 12000 * BitRate / SampleRate ) + PaddingBit ) * 4 ; break ;		// Layer-1
				case 1 :
				case 2 : FrameSize = ( 144000 * BitRate / SampleRate ) + PaddingBit ; break ;				// Layer-2 Layer-3
				}
				break ;

			case 1 : // Mapg-2
				switch( Layer )
				{
				case 0 : FrameSize = ( ( 12000 * BitRate / SampleRate ) + PaddingBit ) * 4 ; break ;		// Layer-1
				case 1 :
				case 2 : FrameSize = ( 72000 * BitRate / SampleRate ) + PaddingBit ; break ;				// Layer-2 Layer-3
				}
				break ;
			}
//			FrameSize += 4 ;
*/
			// Tv𑝂₷
			acmdata->DestDataSampleNum += MP3Frame.SampleNum ;

			// f[^̖[AhX擾
			{
				LastPoint = ( DWORD )( Stream->ReadShred.Tell( Stream->DataPoint ) /*- 8*/ + MP3Frame.FrameSize - 4 ) ;
				if( LastPoint >= FileSize - EndSkipSize )
				{
					if( LastPoint > FileSize - EndSkipSize ) LastPoint = FileSize - EndSkipSize;
					break ;
				}
				Stream->ReadShred.Seek( Stream->DataPoint, MP3Frame.FrameSize - 4 /*- 8*/, STREAM_SEEKTYPE_CUR ) ;
				i ++ ;
			}
		}
	}

R1 :
	// t[f[^ȂG[
	if( StartPos == 0xffffffff ) return -1 ;

	// ʒuZbg
/*	Stream->ReadShred.Seek( Stream->DataPoint, SkipSize, STREAM_SEEKTYPE_SET ) ;

	// t[f[^T
	{
		while( 1 )
		{
			if( Stream->ReadShred.Read( &Header[0], 1, 1, Stream->DataPoint ) == 0 ) return -1 ;
			if( Header[0] == 0xff )
			{
				if( Stream->ReadShred.Read( &Header[1], 1, 1, Stream->DataPoint ) == 0 ) return -1 ;
				if( ( Header[1] & 0xf0 ) == 0xf0 )
				{
					break ;
				}
			}
		}
	}

	// c̃wb_ǂݍ
	Stream->ReadShred.Read( &Header[2], 1, 2, Stream->DataPoint ) ;
*/
	// ŏ̃t[̈ʒuֈړ
	Stream->ReadShred.Seek( Stream->DataPoint, StartPos, STREAM_SEEKTYPE_SET ) ;

	// wb_ǂݍ
	Stream->ReadShred.Read( &Header[0], 1, 4, Stream->DataPoint ) ;

	// wb_
	if( AnalysisMP3_FrameHeader( Header, &MP3Frame ) < 0 ) return -1 ;
/*
	// loRf[^ׂ
	if( Header[0] != 0xff || ( Header[1] & 0xf0 ) != 0xf0 ) return -1 ;

	// lodf̃o[W𓾂(0:Ver1 1:Ver2)
	MpegV = ( Header[1] & 0x8 ) == 0x8 ? 0 : 1 ;

	// C𓾂(0:Layer-1 1:Layer-2 2:Layer-3)
	Layer = 3 - ( ( Header[1] >> 1 ) & 0x3 ) ;

	// rbg[g̃CfbNXl𓾂
	BitRateIndex = ( Header[2] >> 4 ) & 0xf ;

	// rbg[g𓾂
	BitRate = MP3BitRateTable[MpegV][Layer][BitRateIndex-1] ;

	// TvOg̃CfbNXl𓾂
	SampleRateIndex = ( Header[2] >> 2 ) & 0x3 ;

	// TvOg𓾂
	SampleRate = MP3FreqTable[MpegV][SampleRateIndex] ;

	// pfBOrbg𓾂
	PaddingBit = ( Header[2] >> 1 ) & 1 ;

	// `l[h`l𓾂
	ChannelNum = ( ( Header[3] >> 6 ) & 0x3 ) == 3 ? 1 : 2 ;

	// t[TCYvZ
	switch( MpegV )
	{
	case 0 : // Mapg-1
		switch( Layer )
		{
		case 0 : FrameSize = ( ( 12000 * BitRate / SampleRate ) + PaddingBit ) * 4 ; break ;		// Layer-1
		case 1 :
		case 2 : FrameSize = ( 144000 * BitRate / SampleRate ) + PaddingBit ; break ;				// Layer-2 Layer-3
		}
		break ;

	case 1 : // Mapg-2
		switch( Layer )
		{
		case 0 : FrameSize = ( ( 12000 * BitRate / SampleRate ) + PaddingBit ) * 4 ; break ;		// Layer-1
		case 1 :
		case 2 : FrameSize = ( 72000 * BitRate / SampleRate ) + PaddingBit ; break ;				// Layer-2 Layer-3
		}
		break ;
	}
//	FrameSize += 4 ;
*/
	// wb_̃Zbg
	{
		// ̊m
		int headerSize = sizeof( MPEGLAYER3WAVEFORMAT );
		GSoundConvertData.acmMetricsFunc( NULL, ACM_METRIC_MAX_SIZE_FORMAT, &headerSize );

		MP3Format = ( MPEGLAYER3WAVEFORMAT * )DXALLOC( headerSize ) ;
		if( MP3Format == NULL ) goto ERR ;

		// loRv`udtH[}bg̃f[^Zbg
		_MEMSET( MP3Format, 0, headerSize ) ;
		MP3Format->wfx.cbSize = MPEGLAYER3_WFX_EXTRA_BYTES ;
		MP3Format->wfx.wFormatTag = WAVE_FORMAT_MPEGLAYER3 ;
		MP3Format->wfx.nChannels = MP3Frame.ChannelNum ;
		MP3Format->wfx.nSamplesPerSec = MP3Frame.SampleRate ;
		MP3Format->wfx.nAvgBytesPerSec = MP3Frame.BitRate * 1000 / 8 ;
		MP3Format->wfx.nBlockAlign = 1 ;
		MP3Format->wfx.wBitsPerSample = 0 ;
		MP3Format->wID = MPEGLAYER3_ID_MPEG ;
		MP3Format->fdwFlags = MP3Frame.PaddingBit/*0*//*MPEGLAYER3_FLAG_PADDING_OFF*/ ;
		MP3Format->nBlockSize = ( WORD )MP3Frame.FrameSize ;
		MP3Format->nFramesPerBlock = 1 ;
		MP3Format->nCodecDelay = 700/*0x0571*/ ;
	}
/*
	// f[^̃X^[gAhX擾
	StartPoint = Stream->ReadShred.Tell( Stream->DataPoint ) - 4 ;
*/

	// Lf[^TCY擾
	DataSize = LastPoint - StartPos ;
//	DataSize = LastPoint - StartPoint ;
//	DataSize = FileSize - SkipSize - EndSkipSize ;

	// t@C|C^̑
	Stream->ReadShred.Seek( Stream->DataPoint, StartPos, STREAM_SEEKTYPE_SET ) ;
//	Stream->ReadShred.Seek( Stream->DataPoint, StartPoint, STREAM_SEEKTYPE_SET ) ;

	// ̃Zbg
	acmdata->Format = ( WAVEFORMATEX * )MP3Format ;
//	SoundConv->DataPos = StartPoint ;
	SoundConv->DataPos = StartPos ;
	SoundConv->DataSize = DataSize ;

	// ϊ̐tH[}bg𓾂
	_MEMSET( &SoundConv->OutFormat, 0, sizeof( SoundConv->OutFormat ) ) ;
	SoundConv->OutFormat.wFormatTag = WAVE_FORMAT_PCM ;
	res = GSoundConvertData.acmFormatSuggestFunc( NULL, acmdata->Format, &SoundConv->OutFormat, sizeof( WAVEFORMATEX ), ACM_FORMATSUGGESTF_WFORMATTAG ) ;
	if( res != 0 ) goto ERR ;

	// kf[^ꎞIɕۑ郁̈̊m
//	acmdata->SrcDataSize = AdjustSoundDataBlock( acmdata->Format->nAvgBytesPerSec * 8/* / STS_CACHEBUFFERSEC*/, acmdata->Format ) ;
	acmdata->SrcDataSize = SoundConv->DataSize ;  // [v̊֌WŁAہXf[^܂̈mۂ
	acmdata->SrcData = DXALLOC( acmdata->SrcDataSize ) ;
	if( acmdata->SrcData == NULL ) goto ERR ;
//	acmdata->SrcDataValidSize = 0 ;

	// kf[^ꊇœǂݍ
	Stream->ReadShred.Read( acmdata->SrcData, SoundConv->DataSize, 1, Stream->DataPoint ) ;
	Stream->ReadShred.Seek( Stream->DataPoint, StartPos, STREAM_SEEKTYPE_SET ) ;
//	acmdata->SrcDataValidSize = SoundConv->DataSize ;
	acmdata->SrcDataPosition = 0 ;

	// `blnh̍쐬
	for( i = 0 ; i < 2 ; i ++ )
	{
		res = GSoundConvertData.acmStreamOpenFunc( &acmdata->AcmStreamHandle[i],
								NULL,
								acmdata->Format,
								&SoundConv->OutFormat,
								NULL,
								0,
								0,
								ACM_STREAMOPENF_NONREALTIME ) ;
		if( res != 0 ) goto ERR ;
	}

	// ϊ̂oblf[^ꎞIɕۑ郁̈̃TCYZbg(Pb傫߂ɂƂĂ)
	SoundConv->DestDataSize = SoundConv->OutFormat.nAvgBytesPerSec * 4 / 3;
	
	// V[N\ʒu܂ŕϊĂŎgp郁̈̊m
	acmdata->BeginSeekBuffer = DXALLOC( SoundConv->DestDataSize ) ;
	if( acmdata->BeginSeekBuffer == NULL ) goto ERR ;

	// ^CvZbg
	SoundConv->MethodType = SOUND_METHODTYPE_ACM ;

	// I
	return 0 ;
	
ERR :
	if( acmdata->AcmStreamHandle[0] != NULL )
	{
		GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[0], 0 ) ;
		acmdata->AcmStreamHandle[0] = NULL ;
	}

	if( acmdata->AcmStreamHandle[1] != NULL )
	{
		GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[1], 0 ) ;
		acmdata->AcmStreamHandle[1] = NULL ;
	}

	if( acmdata->BeginSeekBuffer != NULL )
	{
		DXFREE( acmdata->BeginSeekBuffer ) ;
		acmdata->BeginSeekBuffer = NULL ;
	}

	if( acmdata->Format != NULL )
	{
		DXFREE( acmdata->Format ) ;
		acmdata->Format = NULL ;
	}

	if( acmdata->SrcData != NULL )
	{
		DXFREE( acmdata->SrcData ) ;
		acmdata->SrcData = NULL ;
	}
	
	return -1 ;
}

#endif

// v`udt@Čns
static	int TerminateSoundConvert_WAVE( SOUNDCONV *SoundConv )
{
	SOUNDCONV_WAVE *Wave = ( SOUNDCONV_WAVE * )SoundConv->ConvFunctionBuffer ;

	// 
	if( Wave->SrcBuffer )
	{
		DXFREE( Wave->SrcBuffer ) ;
		Wave->SrcBuffer = NULL ;
	}

	// I
	return 0 ;
}

#ifndef DX_NON_ACM

// `blgpt@Čns
static	int TerminateSoundConvert_ACM( SOUNDCONV *SoundConv )
{
//	SOUNDCONV_ACM *acmdata = &SoundConv->AcmTypeData ;
	SOUNDCONV_ACM *acmdata = (SOUNDCONV_ACM *)SoundConv->ConvFunctionBuffer ;

	if( acmdata->Format != NULL )
	{
		DXFREE( acmdata->Format ) ;
		acmdata->Format = NULL ;
	}

	if( acmdata->BeginSeekBuffer != NULL )
	{
		DXFREE( acmdata->BeginSeekBuffer ) ;
		acmdata->BeginSeekBuffer = NULL ;
	}
	
	if( acmdata->AcmStreamHandle[0] != NULL )
	{
		GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[0], 0 ) ;
		acmdata->AcmStreamHandle[0] = NULL ;
	}

	if( acmdata->AcmStreamHandle[1] != NULL )
	{
		GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[1], 0 ) ;
		acmdata->AcmStreamHandle[1] = NULL ;
	}
	
	if( acmdata->SrcData != NULL )
	{
		DXFREE( acmdata->SrcData ) ;
		acmdata->SrcData = NULL ;
	}

	return 0 ;
}

#endif

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3

// MP3gpt@Čns
static int TerminateSoundConvert_DSMP3( SOUNDCONV *SoundConv )
{
	SOUNDCONV_DSMP3 *dsmp3 = ( SOUNDCONV_DSMP3 * )SoundConv->ConvFunctionBuffer ;

	if( dsmp3->PCMBuffer )
	{
		DXFREE( dsmp3->PCMBuffer ) ;
		dsmp3->PCMBuffer = NULL ;
	}

	return 0 ;
}

#endif
#endif
#endif

// ϊ̃obt@Ƀf[^[
static	int ConvertProcessSoundConvert_WAVE( SOUNDCONV *SoundConv )
{
	int readsize, pos ;
	STREAMDATA *Stream = &SoundConv->Stream ;
	SOUNDCONV_WAVE *Wave = ( SOUNDCONV_WAVE * )SoundConv->ConvFunctionBuffer ;

	switch( Wave->SrcFormat.wFormatTag )
	{
	case WAVE_FORMAT_PCM :
		pos = ( int )( Stream->ReadShred.Tell( Stream->DataPoint ) - SoundConv->DataPos ) ;
		if( pos == SoundConv->DataSize ) return -1 ;

		// ǂݍރf[^TCY肷
		readsize = SoundConv->DataSize - pos ;
		if( SoundConv->DestDataSize < readsize ) readsize = SoundConv->DestDataSize ;

		// ǂݍ
		Stream->ReadShred.Read( SoundConv->DestData,
								readsize, 1, Stream->DataPoint ) ;
		SoundConv->DestDataValidSize = readsize ;
		break ;

	case WAVE_FORMAT_IEEE_FLOAT :
		{
			short *Dest ;
			float *Src ;
			DWORD i ;
			DWORD SampleNum ;
			int j ;
			int DestI ;

			pos = ( int )( Stream->ReadShred.Tell( Stream->DataPoint ) - SoundConv->DataPos ) ;
			if( pos == SoundConv->DataSize ) return -1 ;

			// ǂݍރf[^TCY肷
			readsize = SoundConv->DataSize - pos ;
			if( Wave->SrcBufferSize < ( DWORD )readsize ) readsize = Wave->SrcBufferSize ;

			// ǂݍ
			Stream->ReadShred.Read( Wave->SrcBuffer,
									readsize, 1, Stream->DataPoint ) ;

			// ^ɕϊ
			Dest = ( short * )SoundConv->DestData ;
			Src = ( float * )Wave->SrcBuffer ;
			SampleNum = readsize / Wave->SrcFormat.nBlockAlign ;
			for( i = 0 ; i < SampleNum ; i ++ )
			{
				for( j = 0 ; j < Wave->SrcFormat.nChannels ; j ++, Dest ++, Src ++ )
				{
					DestI = _FTOL( *Src * 32768.0f ) ;
					if( DestI < -32768 )
					{
						*Dest = -32768 ;
					}
					else
					if( DestI > 32767 )
					{
						*Dest = 32767 ;
					}
					else
					{
						*Dest = ( short )DestI ;
					}
				}
			}
			SoundConv->DestDataValidSize = SampleNum * SoundConv->OutFormat.nBlockAlign ;
		}
		break ;
	}

	return 0 ;
}

#ifndef DX_NON_ACM

// ϊ̃obt@Ƀf[^[
static	int ConvertProcessSoundConvert_ACM( SOUNDCONV *SoundConv )
{
	ACMSTREAMHEADER header ;
//	SOUNDCONV_ACM *acmdata = &SoundConv->AcmTypeData ;
	SOUNDCONV_ACM *acmdata = (SOUNDCONV_ACM *)SoundConv->ConvFunctionBuffer ;
//	STREAMDATA *Stream = &SoundConv->Stream ;
	DWORD ConvSize = 0 ;

	// V[N\ʒuƃTuACMnhŕϊĂʒuႤꍇ͏s
	if( SoundConv->SeekLockPosition != acmdata->BeginSeekPosition )
	{
		// ǂzĂ܂Ăꍇ͍ŏ蒼
		if( acmdata->BeginSeekPosition > SoundConv->SeekLockPosition )
		{
			GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[1], 0 ) ;
			GSoundConvertData.acmStreamOpenFunc( &acmdata->AcmStreamHandle[1], NULL,
							acmdata->Format, &SoundConv->OutFormat,
							NULL, 0, 0, ACM_STREAMOPENF_NONREALTIME ) ;
			acmdata->BeginSeekPosition = 0 ;
			acmdata->BeginSeekCompSrcSize = 0 ;
		}

		if( SoundConv->SeekLockPosition - 1024 * 10 > acmdata->BeginSeekPosition )
		{
			// ϊς݂̈ʒui߂
			_MEMSET( &header, 0, sizeof( ACMSTREAMHEADER ) ) ;
			header.cbStruct		= sizeof( ACMSTREAMHEADER ) ;
			header.pbSrc		= (BYTE *)acmdata->SrcData + acmdata->BeginSeekCompSrcSize ;
			if( acmdata->SrcDataSize - acmdata->BeginSeekCompSrcSize > 2048 ) header.cbSrcLength = 2048 ;
			else 	                                                          header.cbSrcLength = acmdata->SrcDataSize - acmdata->BeginSeekCompSrcSize ;
			header.pbDst		= (BYTE *)acmdata->BeginSeekBuffer ;
			header.cbDstLength	= SoundConv->DestDataSize ;
			if( (signed)( header.cbDstLength + acmdata->BeginSeekPosition ) > SoundConv->SeekLockPosition ) 
				header.cbDstLength = SoundConv->SeekLockPosition - acmdata->BeginSeekPosition ;

			if( GSoundConvertData.acmStreamPrepareHeaderFunc( acmdata->AcmStreamHandle[1], &header, 0 ) != 0 )
				return -1 ;

			// WJ
			GSoundConvertData.acmStreamConvertFunc( acmdata->AcmStreamHandle[1], &header, ACM_STREAMCONVERTF_BLOCKALIGN ) ;

			// WJWi߂
			acmdata->BeginSeekPosition += header.cbDstLengthUsed ;
			acmdata->BeginSeekCompSrcSize += header.cbSrcLengthUsed ;

			// wb_̉
			GSoundConvertData.acmStreamUnprepareHeaderFunc( acmdata->AcmStreamHandle[1], &header, 0 ) ;
		}
	}

	// I[܂ŗĂI
	if( acmdata->SrcDataPosition == acmdata->SrcDataSize )
		return -1 ;

	// ϊ̃f[^Xg[ǂݍ݂
//([v̊֌WŃf[^ہXǂݍł邽߂͕̏KvȂȂ)
/*	if( acmdata->SrcDataValidSize < acmdata->SrcDataSize )
	{
		int pos, readsize ;

		pos = Stream->ReadShred.Tell( Stream->DataPoint ) - SoundConv->DataPos ; 
		if( pos == SoundConv->DataSize && acmdata->SrcDataValidSize == 0 )
			return -1 ;

		readsize = SoundConv->DataSize - pos ;
		if( readsize != 0 )
		{
			if( readsize > acmdata->SrcDataSize - acmdata->SrcDataValidSize )
				readsize = acmdata->SrcDataSize - acmdata->SrcDataValidSize ;

			Stream->ReadShred.Read( (BYTE *)acmdata->SrcData + acmdata->SrcDataValidSize,
									readsize, 1, Stream->DataPoint ) ;
			acmdata->SrcDataValidSize += readsize ;
		}
	}
*/

	// WJ̏
	_MEMSET( &header, 0, sizeof( ACMSTREAMHEADER ) ) ;
	header.cbStruct		= sizeof( ACMSTREAMHEADER ) ;
//	header.pbSrc		= (BYTE *)acmdata->SrcData ;
//	header.cbSrcLength	= acmdata->SrcDataValidSize ;
	header.pbSrc		= (BYTE *)acmdata->SrcData + acmdata->SrcDataPosition ;
	if( acmdata->SrcDataSize - acmdata->SrcDataPosition > 2048 ) header.cbSrcLength = 2048 ;
	else 	                                                     header.cbSrcLength = acmdata->SrcDataSize - acmdata->SrcDataPosition ;
	header.pbDst		= (BYTE *)SoundConv->DestData ;
	header.cbDstLength	= SoundConv->DestDataSize ;


	if( GSoundConvertData.acmStreamPrepareHeaderFunc( acmdata->AcmStreamHandle[0], &header, 0 ) != 0 )
		return -1 ;

	// WJ
	GSoundConvertData.acmStreamConvertFunc( acmdata->AcmStreamHandle[0], &header, ACM_STREAMCONVERTF_BLOCKALIGN ) ;

	// f[^̃Zbg
	ConvSize = header.cbDstLengthUsed ;
/*	if( acmdata->DestDataSampleNum != -1 )
	{
		if( ( SoundConv->DestDataCompSize + ConvSize ) / SoundConv->OutFormat.nBlockAlign >= acmdata->DestDataSampleNum )
		{
			ConvSize = ( acmdata->DestDataSampleNum - SoundConv->DestDataCompSize / SoundConv->OutFormat.nBlockAlign ) * SoundConv->OutFormat.nBlockAlign ;
		}
	}
*/
	SoundConv->DestDataValidSize = header.cbDstLengthUsed ;
	acmdata->SrcDataPosition += header.cbSrcLengthUsed ;
//	acmdata->SrcDataValidSize -= header.cbSrcLengthUsed ;

	// wb_̉
	GSoundConvertData.acmStreamUnprepareHeaderFunc( acmdata->AcmStreamHandle[0], &header, 0 ) ;

	// gpꂽf[^̃TCYOŁARo[gTCYO特IĂ
	// \̂ŁȀꍇ̓Ro[gI
	if( ConvSize == 0 )
	{
		SoundConv->DestDataValidSize = 0 ;
		acmdata->SrcDataPosition = acmdata->SrcDataSize ;
//		acmdata->SrcDataValidSize = 0 ;
		return -1 ;
	}

	// cXCh
//([v̊֌WŃf[^ہXǂݍł邽߂͕̏KvȂȂ)
/*	if( acmdata->SrcDataValidSize != 0 )
		_MEMMOVE( acmdata->SrcData,
				 (BYTE *)acmdata->SrcData + header.cbSrcLengthUsed,
				 acmdata->SrcDataValidSize ) ;
*/

	// I
	return 0 ;
}

#endif

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3

// ϊ̃obt@Ƀf[^[
static int ConvertProcessSoundConvert_DSMP3( SOUNDCONV *SoundConv )
{
	SOUNDCONV_DSMP3 *dsmp3 = ( SOUNDCONV_DSMP3 * )SoundConv->ConvFunctionBuffer ;
	int readsize ;

	// Sē]ĂI
	if( dsmp3->PCMValidDataSize == dsmp3->PCMDestCopySize ) return -1 ;
	
	// ]f[^TCY肷
	readsize = dsmp3->PCMValidDataSize - dsmp3->PCMDestCopySize ;
	if( SoundConv->DestDataSize < readsize ) readsize = SoundConv->DestDataSize ;
	
	// ]
	_MEMCPY( SoundConv->DestData, ( BYTE * )dsmp3->PCMBuffer + dsmp3->PCMDestCopySize, readsize ) ;
	SoundConv->DestDataValidSize = readsize ;

	// ]ItZbgi߂
	dsmp3->PCMDestCopySize += readsize ;

	return 0 ;
}

#endif
#endif
#endif

// ϊ̈ʒuύX( TvP )
static int SetSampleTimeSoundConvert_WAVE( SOUNDCONV *SoundConv, int SampleTime )
{
	int BytePos ;
	STREAMDATA *Stream = &SoundConv->Stream ;
	
	BytePos = SampleTime * SoundConv->OutFormat.nBlockAlign + SoundConv->DataPos ;
	Stream->ReadShred.Seek( Stream->DataPoint, BytePos, SEEK_SET ) ;

	SoundConv->DestDataValidSize = 0 ;
	SoundConv->DestDataCompSize = 0 ;
	SoundConv->DestDataCompSizeAll = BytePos ;

	return 0 ;
}

#ifndef DX_NON_ACM

// ϊ̈ʒuύX( TvP )
static int SetSampleTimeSoundConvert_ACM( SOUNDCONV *SoundConv, int SampleTime )
{
	int BytePos, CurPos, res, DelByte ;
	STREAMDATA *Stream = &SoundConv->Stream ;
//	SOUNDCONV_ACM *acmdata = &SoundConv->AcmTypeData ;
	SOUNDCONV_ACM *acmdata = (SOUNDCONV_ACM *)SoundConv->ConvFunctionBuffer ;

	BytePos = SampleTime * SoundConv->OutFormat.nBlockAlign ;
	CurPos = SoundConv->DestDataCompSizeAll ;
	
	// x݉𓀂Ă镔̎w肾ꍇ͏𕪊
	if( BytePos >= CurPos && BytePos <= CurPos + SoundConv->DestDataValidSize )
	{
		DelByte = BytePos - CurPos ;
		SoundConv->DestDataCompSize += DelByte ;
		SoundConv->DestDataCompSizeAll += DelByte ;
		SoundConv->DestDataValidSize -= DelByte ;
		
		// I
		return 0 ;
	}
	
	// ϊςł܂Ăn_ɖ߂ꍇ͂`blnh쐬ȂA
	// Xg[|Cgf[^̍ŏɖ߂
	if( BytePos < CurPos )
	{
		// ̂`blnhẅʒuƓAʒuIɎOłꍇ͂gp
		if( BytePos >= acmdata->BeginSeekPosition )
		{
			HACMSTREAM temp ;

			// `blnȟ
			temp = acmdata->AcmStreamHandle[0] ;
			acmdata->AcmStreamHandle[0] = acmdata->AcmStreamHandle[1] ;
			acmdata->AcmStreamHandle[1] = temp ;

			// 
			acmdata->SrcDataPosition = acmdata->BeginSeekCompSrcSize ;
			SoundConv->DestDataCompSize = acmdata->BeginSeekPosition ;
			SoundConv->DestDataCompSizeAll = acmdata->BeginSeekPosition ;
			SoundConv->DestDataValidSize = 0 ;

			// ܂ŃC`blnh͏
			GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[1], 0 ) ;
			GSoundConvertData.acmStreamOpenFunc( &acmdata->AcmStreamHandle[1], NULL,
							acmdata->Format, &SoundConv->OutFormat,
							NULL, 0, 0, ACM_STREAMOPENF_NONREALTIME ) ;
			acmdata->BeginSeekCompSrcSize = 0 ;
			acmdata->BeginSeekPosition = 0 ;
		}
		else
		{
			// Tuʖڂȏꍇ̓C蒼ĈꂩǂȂ
			GSoundConvertData.acmStreamCloseFunc( acmdata->AcmStreamHandle[0], 0 ) ;
			GSoundConvertData.acmStreamOpenFunc( &acmdata->AcmStreamHandle[0], NULL,
							acmdata->Format, &SoundConv->OutFormat,
							NULL, 0, 0, ACM_STREAMOPENF_NONREALTIME ) ;
			Stream->ReadShred.Seek( Stream->DataPoint, SoundConv->DataPos, SEEK_SET ) ;
			acmdata->SrcDataPosition = 0 ;
//			acmdata->SrcDataValidSize = 0 ;

			SoundConv->DestDataValidSize = 0 ;
			SoundConv->DestDataCompSize = 0 ;
			SoundConv->DestDataCompSizeAll = 0 ;
		}
	}
	
	// ẅʒu܂ŉ𓀏i߂
	res = 0 ;
	while( SoundConv->DestDataCompSizeAll + SoundConv->DestDataValidSize < BytePos )
	{
		SoundConv->DestDataCompSizeAll += SoundConv->DestDataValidSize ;
		SoundConv->DestDataValidSize = 0 ;
		SoundConv->DestDataCompSize = 0 ;
		res = ConvertProcessSoundConvert_ACM( SoundConv ) ;
		if( res == -1 ) break ;
	}
	
	// I[ɓBĂ܂ϊIԂɂ
	if( res == -1 )
	{
		SoundConv->EndFlag = TRUE ;
		SoundConv->DestDataValidSize = 0 ;
		return 0 ;
	}
	
	DelByte = BytePos - SoundConv->DestDataCompSizeAll ;
	SoundConv->DestDataValidSize -= DelByte ;
	SoundConv->DestDataCompSize += DelByte ;
	SoundConv->DestDataCompSizeAll += DelByte ;

	// I
	return 0 ;
}

#endif

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3

// ϊ̈ʒuύX( TvP )
static	int SetSampleTimeSoundConvert_DSMP3( SOUNDCONV *SoundConv, int SampleTime )
{
	int BytePos ;
	SOUNDCONV_DSMP3 *dsmp3 = ( SOUNDCONV_DSMP3 * )SoundConv->ConvFunctionBuffer ;
	
	BytePos = SampleTime * SoundConv->OutFormat.nBlockAlign ;

	SoundConv->DestDataValidSize = 0 ;
	SoundConv->DestDataCompSize = 0 ;
	SoundConv->DestDataCompSizeAll = BytePos ;
	dsmp3->PCMDestCopySize = BytePos ;

	return 0 ;
}

#endif
#endif
#endif


// ϊ̑}̃f[^TCY𓾂
static	int GetSoundConvertDestSize_Fast_WAVE( SOUNDCONV *SoundConv )
{
	SOUNDCONV_WAVE *Wave = ( SOUNDCONV_WAVE * )SoundConv->ConvFunctionBuffer ;

	switch( Wave->SrcFormat.wFormatTag )
	{
	case WAVE_FORMAT_PCM :
		return SoundConv->DataSize ;

	case WAVE_FORMAT_IEEE_FLOAT :
		return SoundConv->DataSize / ( Wave->SrcFormat.wBitsPerSample / SoundConv->OutFormat.wBitsPerSample ) ;
	}

	return -1 ;
}

#ifndef DX_NON_ACM

// ϊ̑}̃f[^TCY𓾂
static	int GetSoundConvertDestSize_Fast_ACM( SOUNDCONV *SoundConv )
{
//	SOUNDCONV_ACM *acmdata = &SoundConv->AcmTypeData ;
	SOUNDCONV_ACM *acmdata = (SOUNDCONV_ACM *)SoundConv->ConvFunctionBuffer ;
	DWORD size ;
	
	if( acmdata->DestDataSampleNum != -1 )
	{
		size = (DWORD)( acmdata->DestDataSampleNum * SoundConv->OutFormat.nBlockAlign ) ;
	}
	else
	{
		GSoundConvertData.acmStreamSizeFunc( acmdata->AcmStreamHandle[0], SoundConv->DataSize, &size, ACM_STREAMSIZEF_SOURCE ) ;
	}
	return size ;
}

#endif


#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_DSHOW_MP3

// ϊ̑}̃f[^TCY𓾂
static int GetSoundConvertDestSize_Fast_DSMP3( SOUNDCONV *SoundConv )
{
	SOUNDCONV_DSMP3 *dsmp3 = ( SOUNDCONV_DSMP3 * )SoundConv->ConvFunctionBuffer ;
	return ( int )dsmp3->PCMValidDataSize ;
}

#endif
#endif
#endif





}
