// -------------------------------------------------------------------------------
// 
// 		cwCu		ʕ`vOwb_t@C
// 
// 				Ver 3.12a
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSBASE_H__
#define __DXGRAPHICSBASE_H__


// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxBaseImage.h"

namespace DxLib
{

// }N` --------------------------------------------------------------------

#define GBASE						GraphicsBaseData
#define MASKD						MaskManageData

// L^ĂLɂȂĂ郉Cg̃CfbNX̐
#define MAX_D3DENABLELIGHTINDEX_NUM			(256)

// ɕ`ł郌_O^[Qbg̍ő吔
#define DX_RENDERTARGET_COUNT				(16)

// gpeNX`Xe[W̍ő吔
#define USE_TEXTURESTAGE_NUM				(12)

// ɓKpłVhE}bv̍ő吔
#define MAX_USE_SHADOWMAP_NUM				(3)

// \̒` --------------------------------------------------------------------

// _^ RECT \
struct RECTF
{
	float left, top ;
	float right, bottom ;
} ;

// OtBbNnh̃ZbgAbvɕKvȃO[of[^Z߂\
struct SETUP_GRAPHHANDLE_GPARAM
{
	DWORD					TransColor ;							// ߐF

	int						CreateImageColorBitDepth ;				// 쐬摜̐F[x
	int						CreateImageChannelBitDepth ;			// 쐬摜̂P`lӂ̃rbg[x( 炪ݒ肳Ăꍇ CreateImageColorBitDepth D悳 )
	int						AlphaTestImageCreateFlag ;				// eXgt摜쐬wtO( AlphaGraphCreateFlag ̕Dx )( eNX`T[tFX̂ )
	int						AlphaChannelImageCreateFlag ;			// `lt摜쐬wtO( DrawValidGraphCreateFlag ̕Dx )
	int						CubeMapTextureCreateFlag ;				// L[u}bveNX`쐬wtO( 1:L[u}bveNX`쐬  0:ʏeNX`쐬 )
	int						BlendImageCreateFlag ;					// uhp摜쐬wtO
	int						UseManagedTextureFlag ;					// }l[WheNX`gp邩AtO( 1:gp  0:gpȂ )

	int						DrawValidImageCreateFlag ;				// `\摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidAlphaImageCreateFlag ;			// `\ȃ`lt摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidFloatTypeGraphCreateFlag ;		// `\Float^摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidGraphCreateZBufferFlag ;		// `\摜쐬ۂɐp̂yobt@쐬邩ǂ
	int						CreateDrawValidGraphChannelNum ;		// `\摜̃`l( eNX`T[tFX̂ )
	int						CreateDrawValidGraphZBufferBitDepth ;	// `\摜̂yobt@̃rbg[x( eNX`T[tFX̂ )
	int						DrawValidMSSamples ;					// `\ȉ摜̃}`TvO
	int						DrawValidMSQuality ;					// `\ȉ摜̃}`TvONIeB

	int						MipMapCount ;							// ō쐬~bv}bv̐( -1:ő僌x܂ō쐬 )
	int						UserMaxTextureSize ;					// [U[w̃eNX`őTCY
	int						NotUseDivFlag ;							// 摜sȂǂ( TRUE:sȂ  FALSE:s )
} ;

// VhE}bvnh̃ZbgAbvɕKvȃO[of[^Z߂\
struct SETUP_SHADOWMAPHANDLE_GPARAM
{
	int						Dummy ;
} ;

// 摜f[^OtBbNnh̍쐬E摜f[^̓]ɕKvȃO[of[^Z߂
struct CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM
{
	SETUP_GRAPHHANDLE_GPARAM InitHandleGParam ;						// OtBbNnh̃ZbgAbvɕKvȃO[of[^

	int						NotUseTransColor;						// ߐFgpȂǂtO(TRUE:gpȂ  FALSE:gp)
	int						UseTransColorGraphCreateFlag ;			// ߐFƂłȂ̋E炩ɂ邩AtO
	int						LeftUpColorIsTransColorFlag ;			// 摜̃sNZF𓧉ߐFɂ邩ǂ̃tO
} ;

#ifndef DX_NON_MOVIE

// [r[t@C̃I[vɕKvȃO[of[^Z߂
struct OPENMOVIE_GPARAM
{
	int						RightAlphaFlag;							// 摜̉EAt@Ƃ݂Ȃnh쐬邩(TRUE:쐬)
	int						A8R8G8B8Flag ;							// 32bitJ[tH[}bg̓ A8R8G8B8 `ƂĈǂ̃tO
} ;

#endif // DX_NON_MOVIE

// 摜̌f[^̏ɕKvȃO[of[^Z߂
struct SETGRAPHBASEINFO_GPARAM
{
	int						NotGraphBaseDataBackupFlag ;			// OtBbNnh쐬ۂɎgp摜f[^obNAbvȂǂ̃tO( TRUE:obNAbvȂ  FALSE:obNAbv )
} ;

// t@COtBbNnh쐬鏈ɕKvȃO[of[^Z߂
struct LOADGRAPH_GPARAM
{
	LOADBASEIMAGE_GPARAM	LoadBaseImageGParam ;					// 摜f[^̓ǂݍ݂ɕKvȃO[of[^
#ifndef DX_NON_MOVIE
	OPENMOVIE_GPARAM		OpenMovieGParam ;						// [r[t@C̃I[vɕKvȃO[of[^
#endif
	CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM CreateGraphGParam ;	// OtBbNnh̍쐬EɕKvȃO[of[^
	SETGRAPHBASEINFO_GPARAM	SetGraphBaseInfoGParam ;				// 摜̌f[^̏̕ۑɕKvȃO[of[^
} ;

// OtBbNf[^ǂݍ݈Z߂
struct LOADGRAPH_PARAM
{
	LOADGRAPH_GPARAM		GParam ;
	int						ReCreateFlag ;
	int						GrHandle ;
	int						BaseHandle ;

	const TCHAR *			FileName ;
	const void *			RgbMemImage ;
	int						RgbMemImageSize ;
	const void *			AlphaMemImage ;
	int						AlphaMemImageSize ;
	const BITMAPINFO *		RgbBmpInfo ;
	void *					RgbBmpImage ;
	const BITMAPINFO *		AlphaBmpInfo ;
	void *					AlphaBmpImage ;
	BASEIMAGE *				RgbBaseImage ;
	BASEIMAGE *				AlphaBaseImage ;

	int						AllNum ;
	int						XNum ;
	int						YNum ;
	int						SizeX ;
	int						SizeY ;
	int *					HandleBuf ;
	int						TextureFlag ;
	int						ReverseFlag ;
	int						SurfaceMode ;
} ;

// Cgnh\
struct LIGHT_HANDLE
{
	unsigned int			ID ;												// G[`FbNp̂hc
	int						Handle ;											// g̃nhl

	LIGHTPARAM				Param ;												// Cg̃p[^
	int						SetD3DIndex ;										// Direct3D ̃ZbgĂCfbNX( -1:ZbgĂȂ )
	int						EnableFlag ;										// LtO
	int						ChangeFlag ;										// Direct3D ɔfĂȂݒ肪邩ǂ̃tO( TRUE:  FALSE:Ȃ )
	int						ShadowMapSlotDisableFlag[ MAX_USE_SHADOWMAP_NUM ] ;	// VhE}bvgpȂǂ̃tO( TRUE:gpȂ  FALSE:gp )
} ;

// Cg֌W̍\
struct LIGHTBASEDATA
{
	int						ProcessDisable ;						// Cg𖳌ɂ邩ǂ
	int						ChangeMaterial ;						// CgvZp}eAύXǂ̃tO
	MATERIALPARAM			Material ;								// CgvZp}eA
	int						MaterialNotUseVertexDiffuseColor ;		// CgvZɒ_̃fBt[YJ[gpȂǂ
	int						MaterialNotUseVertexSpecularColor;		// CgvZɒ_̃XyLJ[gpȂǂ
	LIGHT_HANDLE			*Data[ MAX_LIGHT_NUM ] ;				// Cgւ̃|C^
	int						Num ;									// Cg̐
	int						Area ;									// LȃCg͈
	int						HandleID ;								// CgɊ蓖Ăhc
	int						EnableNum ;								// LɂȂĂ郉Cg̐
	int						MaxD3DEnableIndex ;						// Direct3DDevice ɑ΂ėLɂȂĂ郉Cgňԑ傫Ȓl̃CfbNX
	int						EnableD3DIndex[ MAX_D3DENABLELIGHTINDEX_NUM ] ;	// Direct3DDevice ɑ΂ėLɂĂ郉Cg̃Xg
	int						D3DChange ;								// Direct3DDevice ւ̔fKvȕύXǂ̃tO
	int						D3DRefresh ;							// Direct3DDevice ւ̑Sڂ̔fKvǂ̃tO
	int						DefaultHandle ;							// ftHgCgpnh
} ;

// OtBbN`{f[^^
struct GRAPHICSBASEDATA
{
	void					( *GraphRestoreShred )( void ) ;		// OtBbN֐̃|C^ 

	int						TargetScreen[ DX_RENDERTARGET_COUNT ] ;	// `OtBbNʒl
	int						TargetScreenSurface[ DX_RENDERTARGET_COUNT ] ; // `OtBbNT[tFXCfbNX
	int						TargetScreenVramFlag ;					// `OtBbNuq`lɑ݂邩ۂ
	int						TargetZBuffer ;							// `yobt@ʒl
	RECT					WindowDrawRect ;						// fXNgbv̂T[tFXɕ`揈s
																	// ꍇEChẼNCAg̈̋`f[^Ă
	RECT					DrawArea ;								// `\`
	RECTF					DrawAreaF ;								// `\`_^
	int						DrawSizeX, DrawSizeY ;					// `Ώۂ̃TCY
	float					Draw3DScale ;							// Rc`揈̃XP[

	int						ProjectionMatrixMode ;					// ˉes񃂁[h( 0:ߖ@  1:ˉe  2:sw )
	float					ProjNear, ProjFar ;						// yNbsO Nearʂ Far
	float					ProjDotAspect ;							// hbgAXyNg( c /  )
	float					ProjFov ;								// ߖ@̎p
	float					ProjSize ;								// ˉẽTCY
	MATRIX					ProjMatrix ;							// ˉes

	int						EnableZBufferFlag2D ;					// yobt@̗LtO
	int						WriteZBufferFlag2D ;					// yobt@̍XVsAtO
	int						ZBufferCmpType2D ;						// yl̔r[h
	int						ZBias2D ;								// yoCAX
	int						EnableZBufferFlag3D ;					// yobt@̗LtO
	int						WriteZBufferFlag3D ;					// yobt@̍XVsAtO
	int						ZBufferCmpType3D ;						// yl̔r[h
	int						ZBias3D ;								// yoCAX
	int						FillMode ;								// tB[h
	int						CullMode ;								// JO[h
	int						TexAddressModeU[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[ht
	int						TexAddressModeV[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[hu
	int						TexAddressModeW[ USE_TEXTURESTAGE_NUM ] ;	// eNX`AhX[hv
	int						FogEnable ;								// tHOLǂ( TRUE:L  FALSE: )
	int						FogMode ;								// tHO[h
	DWORD					FogColor ;								// tHOJ[
	float					FogStart, FogEnd ;						// tHOJnAhXƏIAhX
	float					FogDensity ;							// tHOx
	float					DrawZ;									// Qc`掞ɂyobt@ɏނyl
	int						DrawMode ;								// `惂[h
	int						MaxAnisotropy ;							// őٕ
	int						AlphaChDrawMode ;						// `ɐlނǂ( TRUE:l  FALSE:ʏ탂[h )
	int						BlendMode ;								// uh[h
	int						BlendParam ;							// uhp[^
	int						BlendGraph ;							// uhOtBbNnh
	int						BlendGraphType ;						// uhOtBbN^Cv
	int						BlendGraphFadeRatio ;					// uhOtBbÑtF[hp[^
	int						BlendGraphBorderParam ;					// uhOtBbNnh̃uhEl(0`255)
	int						BlendGraphBorderRange ;					// uhOtBbNnh̋E̕(0`255)
	int						BlendGraphX, BlendGraphY ;				// uhOtBbN̋N_W
	int						AlphaTestMode ;							// At@eXg[h
	int						AlphaTestParam ;						// At@eXgp[^
	int						NotUseSpecular ;						// XyLgpȂǂ
	int						ShadowMap[ MAX_USE_SHADOWMAP_NUM ] ;	// VhE}bvOtBbNnh

	union
	{
		RGBCOLOR			DrawBright ;							// `Px
		DWORD				bDrawBright ;
	} ;
	int						IgnoreGraphColorFlag ;					// `悷摜̐F𖳎邩ǂ̃tO

	int						NotGraphBaseDataBackupFlag ;			// OtBbNnh쐬ۂɎgp摜f[^obNAbvȂǂ̃tO( TRUE:obNAbvȂ  FALSE:obNAbv )
	int						CreateImageColorBitDepth ;				// 쐬摜̐F[x
	int						CreateImageChannelBitDepth ;			// 쐬摜̂P`lӂ̃rbg[x( 炪ݒ肳Ăꍇ CreateImageColorBitDepth D悳 )
	int						TextureImageCreateFlag ;				// eNX`摜쐬tO
	int						DrawValidImageCreateFlag ;				// `\摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidAlphaImageCreateFlag ;			// `\ȃ`lt摜쐬wtO( eNX`T[tFX̂ )
	int						DrawValidFloatTypeGraphCreateFlag ;		// `\Float^摜쐬wtO( eNX`T[tFX̂ )
	int						NotDrawValidGraphCreateZBufferFlag ;	// `\摜쐬ۂɐp̂yobt@͍쐬Ȃǂ
	int						CreateDrawValidGraphChannelNum ;		// `\摜̃`l( eNX`T[tFX̂ )
	int						CreateDrawValidGraphZBufferBitDepth ;	// `\摜̂yobt@̃rbg[x( eNX`T[tFX̂ )
	int						DrawValidMSSamples ;					// `\ȉ摜̃}`TvO
	int						DrawValidMSQuality ;					// `\ȉ摜̃}`TvONIeB
	int						UseNoBlendModeParam ;					// DX_BLENDMODE_NOBLEND ł Param ̒lgp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ )
	int						AlphaChannelImageCreateFlag ;			// `lt摜쐬wtO( DrawValidGraphCreateFlag ̕Dx )
	int						AlphaTestImageCreateFlag ;				// eXgt摜쐬wtO( AlphaGraphCreateFlag ̕Dx )( eNX`T[tFX̂ )
	int						CubeMapTextureCreateFlag ;				// L[u}bveNX`쐬wtO( 1:L[u}bveNX`쐬  0:ʏeNX`쐬 )
	int						SystemMemImageCreateFlag ;				// VXegp摜쐬wtO( WT[tFX̂ )
	int						BlendImageCreateFlag ;					// uhp摜쐬wtO
	int						NotUseManagedTextureFlag ;				// }l[WheNX`gpȂAtO( 1:gpȂ  0:gp )
	int						LeftUpColorIsTransColorFlag ;			// 摜̃sNZF𓧉ߐFɂ邩ǂ̃tO
	int						NotUseBasicGraphDraw3DDeviceMethodFlag ;// P}`̕`ɂRcfoCX̋@\gpȂǂ̃tO
	int						NotWaitVSyncFlag ;						// urxmb҂Ȃǂ̃tOiTRUEFȂ FALSEFj
	int						PreSetWaitVSyncFlag ;					// DxLib_Init Ă΂O SetWaitVSyncFlag( TRUE ) ; sꂽǂ̃tO( TRUE:sꂽ  FALSE:sĂȂ )
	int						Emulation320x240Flag ;					// 640x480 ̉ʂ 320x240 ̉ʂo͂邩ǂ̃tO

	DWORD					TransColor ;							// ߐF
	int						NotUseTransColor;						// ߐFgpȂǂtO(TRUE:gpȂ  FALSE:gp)
	int						UseTransColorGraphCreateFlag ;			// ߐFƂłȂ̋E炩ɂ邩AtO

	int						NotDrawFlag ;							// `s\tO
	int						NotDrawFlagInSetDrawArea ;				// `s\tOiSetDrawAreapj

	int						ScreenFlipFlag ;						// ScreenFlip֐ĂтtO

	int						Screen3DWidth, Screen3DHeight ;			// Rc`sۂ̑z肷XN[̃TCY
	int						Screen3DCenterX, Screen3DCenterY ;		// Rc`sۂ̑z肷XN[̒SW
	LONGLONG				FrameCounter ;							// t[JE^[

	int						MatchHardwareMatrix ;					// RcfoCXɐݒ肳ĂsƖ{\̒̍s񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	int						MatchHardwareWorldMatrix ;				// RcfoCXɐݒ肳Ă郏[hϊsƖ{\̒̃[hϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX					WorldMatrix ;							// [hϊs
	int						MatchHardwareViewMatrix ;				// RcfoCXɐݒ肳Ăr[ϊsƖ{\̒̃r[ϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX					ViewMatrix ;							// r[ϊs
	int						MatchHardwareProjectionMatrix ;			// RcfoCXɐݒ肳ĂˉeϊsƖ{\̒̎ˉeϊs񂪈vĂ邩ǂ( TRUE:vĂ  FALSE:vĂȂ )
	MATRIX					ProjectionMatrix ;						// ˉeϊs
	MATRIX					ViewportMatrix ;						// r[|[gs
	MATRIX					Direct3DViewportMatrix ;				// cRc Iȃr[|[gs
	MATRIX					Direct3DViewportMatrixAnti ;			// cRc Iȃr[|[gs𖳌ɂs
	int						TextureTransformUse ;					// eNX`Wϊsǂ( TRUE:s  FALSE:sȂ )
	float					TextureTransX, TextureTransY ;			// eNX`sړ
	float					TextureScaleX, TextureScaleY ;			// eNX`g嗦
	float					TextureRotateCenterX, TextureRotateCenterY ;	// eNX`]̒SW
	float					TextureRotate ;							// eNX`]l
	int						TextureMatrixValid ;					// TextureMatrix Lǂ( TRUE:L  FALSE: )
	MATRIX					TextureMatrix ;							// TextureTransX  TextureScaleY ȂǂgpȂŐݒ肷s
	MATRIX					TextureTransformMatrix ;				// eNX`Wϊs
	int						TempVertexBufferSize ;					// ꎞIɒ_f[^i[邽߂̃obt@̃TCY
	void					*TempVertexBuffer ;						// ꎞIɒ_f[^i[邽߂̃obt@

	int						ValidBlendMatrix ;						// BlendMatrix, ViewProjectionMatrix, BillboardMatrix Lǂ( TRUE:L  FALSE: )
	MATRIX					BlendMatrix ;							// [hϊAr[ϊAˉeϊAr[|[gϊs|킹
	int						ValidInverseBlendMatrix ;				// BlendMatrix ̋ts񂪗Lǂ( TRUE:L  FALSE: )
	MATRIX					InverseBlendMatrix ;					// BlendMatrix ̋ts
	MATRIX					ViewProjectionViewportMatrix ;			// r[sƎˉesƃr[|[gs|킹
	MATRIX					BillboardMatrix ;						// r{[hp̍s
	VECTOR					ViewClipPos[ 2 ][ 2 ][ 2 ] ;			// 䒸_( [ 0:z+ 1:z- ][ 0:top 1:bottom ][ 0:left 1:right ] )
	FLOAT4					ClippingPlane[ 6 ] ;					// NbsO( 0:-x 1:+x 2:-y 3:+y 4:-z 5:+z )
	MATRIX					ConvScreenPosToWorldPosMatrix ;			// ʍWXN[WɕϊۂɎgps
	int						ValidConvScreenPosToWorldPosMatrix ;	// ʍWXN[WɕϊۂɎgps񂪗Lǂ( TRUE:L  FALSE: )

	LIGHTBASEDATA			Light ;									// Cg֌W̏

	VECTOR					CameraPosition ;						// J̈ʒu
	VECTOR					CameraTarget ;							// J̒_
	VECTOR					CameraUp ;								// J̃AbvxNg
	float					CameraHRotate ;							// J̐px
	float					CameraVRotate ;							// J̐px
	float					CameraTRotate ;							// J̔Ppx
	MATRIX					CameraMatrix ;							// r[s
	float					CameraScreenCenterX, CameraScreenCenterY ;	// J̏_
} ;

// ϐ錾 --------------------------------------------------------------

// `̊{Iȏ
extern GRAPHICSBASEDATA GraphicsBaseData ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		InitializeGraphicsBase( void ) ;											// OtBbN`{f[^̏
extern	int		CheckCameraViewClip_Box_PosDim( VECTOR *CheckBoxPos ) ;						// WWŌ`{bNXJ̎EɓĂ邩ǂ𔻒肷( ߂l TRUE:EɓĂȂ  FALSE:EɓĂ )( CheckPos VECTOR 8̔z̐擪AhXAz̊evfԍ̓e 0:+x +y +z   1:-x +y +z   2:-x -y +z   3:+x -y +z   4:+x -y -z   5:+x +y -z   6:-x +y -z   7:-x -y -z )


extern	int		MakeGraph_UseGParam( SETUP_GRAPHHANDLE_GPARAM *GParam, int SizeX, int SizeY, int NotUse3DFlag, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																											// ̃OtBbNnh쐬֐
extern	int		MakeShadowMap_UseGParam( SETUP_SHADOWMAPHANDLE_GPARAM *GParam, int SizeX, int SizeY, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																														// VhE}bvnh쐬
extern	int		CreateGraph_UseGParam(                  LOADGRAPH_PARAM *Param, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																																																			// 摜f[^OtBbNnh쐬֐
extern	int		CreateDivGraph_UseGParam(               LOADGRAPH_PARAM *Param, int ASyncLoadFlag = FALSE ) ;																																																									// 摜f[^𕪊ăOtBbNnh쐬֐
extern	int		LoadBmpToGraph_UseGParam(               LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const TCHAR *GraphName, int TextureFlag, int ReverseFlag, int SurfaceMode = DX_MOVIESURFACE_NORMAL, int ASyncLoadFlag = FALSE ) ;																								// LoadBmpToGraph ̃O[oϐɃANZXȂo[W
extern	int		LoadDivBmpToGraph_UseGParam(            LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const TCHAR *FileName, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag, int ASyncLoadFlag = FALSE ) ;																				// LoadDivBmpToGraph ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphFromMem_UseGParam(           LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const void *MemImage, int MemImageSize, const void *AlphaImage = NULL, int AlphaImageSize = 0, int TextureFlag = TRUE, int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE ) ;																// CreateGraphFromMem ̃O[oϐɃANZXȂo[W
extern	int		CreateDivGraphFromMem_UseGParam(        LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const void *MemImage, int MemImageSize, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf,int TextureFlag, int ReverseFlag, const void *AlphaImage, int AlphaImageSize, int ASyncLoadFlag = FALSE ) ;					// CreateDivGraphFromMem ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphFromBmp_UseGParam(           LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, BITMAPINFO *BmpInfo, void *GraphData, BITMAPINFO *AlphaInfo = NULL, void *AlphaData = NULL, int TextureFlag = TRUE, int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE ) ;													// CreateGraphFromBmp ̃O[oϐɃANZXȂo[W
extern	int		CreateDivGraphFromBmp_UseGParam(        LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const BITMAPINFO *BmpInfo, const void *GraphData, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf,int TextureFlag, int ReverseFlag, const BITMAPINFO *AlphaInfo, const void *AlphaData, int ASyncLoadFlag = FALSE ) ;	// CreateDivGraphFromBmp ̃O[oϐɃANZXȂo[W
extern	int		CreateGraphFromGraphImage_UseGParam(    LOADGRAPH_GPARAM *GParam, int ReCreateFlag, int GrHandle, const BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int TextureFlag = TRUE , int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																	// CreateGraphFromGraphImage ̃O[oϐɃANZXȂo[W
extern	int		CreateDivGraphFromGraphImage_UseGParam( LOADGRAPH_GPARAM *GParam, int ReCreateFlag, const BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag = TRUE , int ReverseFlag = FALSE, int ASyncLoadFlag = FALSE ) ;									// CreateDivGraphFromGraphImage ̃O[oϐɃANZXȂo[W

extern	int		CreateGraphFromGraphImageBase_UseGParam(    CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam, int ReCreateFlag, int GrHandle,   BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int TextureFlag, int ASyncThread = FALSE ) ;																							// CreateGraphFromGraphImageBase ̃O[oϐɃANZXȂo[W
extern	int		CreateDivGraphFromGraphImageBase_UseGParam( CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam, int ReCreateFlag, int BaseHandle, BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag, int ASyncThread = FALSE ) ;		// CreateDivGraphFromGraphImageBase ̃O[oϐɃANZXȂo[W


extern	int		ResetFrameCounter( void ) ;													// t[JE^[
extern	int		IncFrameCounter( void ) ;													// t[JE^[CNg
extern	LONGLONG GetFrameCounter( void ) ;													// t[JE^[̒l擾
extern	int		RefreshLightState( void ) ;													// Cg̕ύX𔽉f
extern	void	RefreshProjectionMatrix( void ) ;											// ˉesp[^ɊÂĎˉes\z
extern	void	RefreshBlendTransformMatrix( void ) ;										// _ϊs|킹sXV
extern	void	SetupDisplayModeData( int *Num, DISPLAYMODEDATA **Buffer ) ;				// fBXvC[hf[^̏ZbgAbv

extern	int		CreateGraphFromGraphImageBase(      BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int TextureFlag ) ;																														// CreateGraphFromGraphImage ̓֐
extern	int		CreateDivGraphFromGraphImageBase(   BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag, int ReverseFlag ) ;							// CreateDivGraphFromGraphImage ̓֐
extern	int		ReCreateGraphFromGraphImageBase(    BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int GrHandle, int TextureFlag ) ;																										// ReCreateGraphFromGraphImage ̓֐
extern	int		ReCreateDivGraphFromGraphImageBase( BASEIMAGE *Image, const BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag , int ReverseFlag ) ;						// ReCreateDivGraphFromGraphImage ̓֐

extern	void	InitCreateGraphHandleAndBltGraphImageGParam( CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM *GParam ) ;			// CREATE_GRAPHHANDLE_AND_BLTGRAPHIMAGE_GPARAM ̃f[^Zbg
extern	void	InitSetupGraphHandleGParam( SETUP_GRAPHHANDLE_GPARAM *GParam ) ;												// SETUP_GRAPHHANDLE_GPARAM ̃f[^Zbg
extern	void	InitSetupGraphHandleGParam_Normal_NonDrawValid( SETUP_GRAPHHANDLE_GPARAM *GParam, int BitDepth = 32, int AlphaChannel = TRUE, int AlphaTest = FALSE ) ;
extern	void	InitSetupGraphHandleGParam_Normal_DrawValid_NoneZBuffer( SETUP_GRAPHHANDLE_GPARAM *GParam, int BitDepth = 32, int AlphaChannel = TRUE ) ;

#ifndef DX_NON_DSHOW_MOVIE
#ifndef DX_NON_MOVIE
extern	void	InitOpenMovieGParam( OPENMOVIE_GPARAM *GParam ) ;																// OPENMOVIE_GPARAM ̃f[^Zbg
#endif
#endif
extern	void	InitSetGraphBaseInfoGParam( SETGRAPHBASEINFO_GPARAM *GParam ) ;													// SETGRAPHBASEINFO_GPARAM ̃f[^Zbg
extern	void	InitLoadGraphGParam( LOADGRAPH_GPARAM *GParam ) ;																// LOADGRAPH_GPARAM ̃f[^Zbg

}

#endif // __DXGRAPHICSBASE_H__
